using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Text;

namespace Com.Raritan.KxGui.Helpers;

public sealed class j
{
	private sealed class a : NameValueCollection
	{
		public override string ToString()
		{
			int count = Count;
			if (count == 0)
			{
				return "";
			}
			StringBuilder stringBuilder = new StringBuilder();
			string[] allKeys = AllKeys;
			for (int k = 0; k < count; k++)
			{
				stringBuilder.AppendFormat("{0}={1}&", allKeys[k], base[allKeys[k]]);
			}
			if (stringBuilder.Length > 0)
			{
				stringBuilder.Length--;
			}
			return stringBuilder.ToString();
		}
	}

	public static void c(string A_0, TextWriter A_1)
	{
		if (A_1 == null)
		{
			throw new NullReferenceException(".NET emulation");
		}
		A_1.Write(Com.Raritan.KxGui.Helpers.i.b(A_0));
	}

	public static string k(string A_0)
	{
		return Com.Raritan.KxGui.Helpers.i.b(A_0);
	}

	public static string j(string A_0)
	{
		return e(A_0, Encoding.UTF8);
	}

	private static char[] a(MemoryStream A_0, Encoding A_1)
	{
		return A_1.GetChars(A_0.GetBuffer(), 0, (int)A_0.Length);
	}

	private static void a(IList A_0, char A_1, Encoding A_2)
	{
		if (A_1 > 'ÿ')
		{
			byte[] bytes = A_2.GetBytes(new char[1] { A_1 });
			foreach (byte b2 in bytes)
			{
				A_0.Add(b2);
			}
		}
		else
		{
			A_0.Add((byte)A_1);
		}
	}

	public static string e(string A_0, Encoding A_1)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_0.IndexOf('%') == -1 && A_0.IndexOf('+') == -1)
		{
			return A_0;
		}
		if (A_1 == null)
		{
			A_1 = Encoding.UTF8;
		}
		long num = A_0.Length;
		List<byte> list = new List<byte>();
		for (int k = 0; k < num; k++)
		{
			char c2 = A_0[k];
			if (c2 == '%' && k + 2 < num && A_0[k + 1] != '%')
			{
				int num2;
				if (A_0[k + 1] == 'u' && k + 5 < num)
				{
					num2 = a(A_0, k + 2, 4);
					if (num2 != -1)
					{
						a(list, (char)num2, A_1);
						k += 5;
					}
					else
					{
						a(list, '%', A_1);
					}
				}
				else if ((num2 = a(A_0, k + 1, 2)) != -1)
				{
					a(list, (char)num2, A_1);
					k += 2;
				}
				else
				{
					a(list, '%', A_1);
				}
			}
			else if (c2 == '+')
			{
				a(list, ' ', A_1);
			}
			else
			{
				a(list, c2, A_1);
			}
		}
		byte[] bytes = list.ToArray();
		list = null;
		return A_1.GetString(bytes);
	}

	public static string a(byte[] A_0, Encoding A_1)
	{
		if (A_0 == null)
		{
			return null;
		}
		return a(A_0, 0, A_0.Length, A_1);
	}

	private static int a(byte A_0)
	{
		char c2 = (char)A_0;
		if (c2 >= '0' && c2 <= '9')
		{
			return c2 - 48;
		}
		if (c2 >= 'a' && c2 <= 'f')
		{
			return c2 - 97 + 10;
		}
		if (c2 >= 'A' && c2 <= 'F')
		{
			return c2 - 65 + 10;
		}
		return -1;
	}

	private static int d(byte[] A_0, int A_1, int A_2)
	{
		int num = 0;
		int num2 = A_2 + A_1;
		for (int k = A_1; k < num2; k++)
		{
			int num3 = a(A_0[k]);
			if (num3 == -1)
			{
				return -1;
			}
			num = (num << 4) + num3;
		}
		return num;
	}

	private static int a(string A_0, int A_1, int A_2)
	{
		int num = 0;
		int num2 = A_2 + A_1;
		for (int k = A_1; k < num2; k++)
		{
			char c2 = A_0[k];
			if (c2 > '\u007f')
			{
				return -1;
			}
			int num3 = a((byte)c2);
			if (num3 == -1)
			{
				return -1;
			}
			num = (num << 4) + num3;
		}
		return num;
	}

	public static string a(byte[] A_0, int A_1, int A_2, Encoding A_3)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_2 == 0)
		{
			return string.Empty;
		}
		if (A_0 == null)
		{
			throw new ArgumentNullException("bytes");
		}
		if (A_1 < 0 || A_1 > A_0.Length)
		{
			throw new ArgumentOutOfRangeException("offset");
		}
		if (A_2 < 0 || A_1 + A_2 > A_0.Length)
		{
			throw new ArgumentOutOfRangeException("count");
		}
		StringBuilder stringBuilder = new StringBuilder();
		MemoryStream memoryStream = new MemoryStream();
		int num = A_2 + A_1;
		for (int k = A_1; k < num; k++)
		{
			if (A_0[k] == 37 && k + 2 < A_2 && A_0[k + 1] != 37)
			{
				int num2;
				if (A_0[k + 1] == 117 && k + 5 < num)
				{
					if (memoryStream.Length > 0)
					{
						stringBuilder.Append(a(memoryStream, A_3));
						memoryStream.SetLength(0L);
					}
					num2 = d(A_0, k + 2, 4);
					if (num2 != -1)
					{
						stringBuilder.Append((char)num2);
						k += 5;
						continue;
					}
				}
				else if ((num2 = d(A_0, k + 1, 2)) != -1)
				{
					memoryStream.WriteByte((byte)num2);
					k += 2;
					continue;
				}
			}
			if (memoryStream.Length > 0)
			{
				stringBuilder.Append(a(memoryStream, A_3));
				memoryStream.SetLength(0L);
			}
			if (A_0[k] == 43)
			{
				stringBuilder.Append(' ');
			}
			else
			{
				stringBuilder.Append((char)A_0[k]);
			}
		}
		if (memoryStream.Length > 0)
		{
			stringBuilder.Append(a(memoryStream, A_3));
		}
		memoryStream = null;
		return stringBuilder.ToString();
	}

	public static byte[] c(byte[] A_0)
	{
		if (A_0 == null)
		{
			return null;
		}
		return c(A_0, 0, A_0.Length);
	}

	public static byte[] i(string A_0)
	{
		return d(A_0, Encoding.UTF8);
	}

	public static byte[] d(string A_0, Encoding A_1)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_1 == null)
		{
			throw new ArgumentNullException("e");
		}
		return c(A_1.GetBytes(A_0));
	}

	public static byte[] c(byte[] A_0, int A_1, int A_2)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_2 == 0)
		{
			return new byte[0];
		}
		int num = A_0.Length;
		if (A_1 < 0 || A_1 >= num)
		{
			throw new ArgumentOutOfRangeException("offset");
		}
		if (A_2 < 0 || A_1 > num - A_2)
		{
			throw new ArgumentOutOfRangeException("count");
		}
		MemoryStream memoryStream = new MemoryStream();
		int num2 = A_1 + A_2;
		for (int k = A_1; k < num2; k++)
		{
			char c2 = (char)A_0[k];
			switch (c2)
			{
			case '+':
				c2 = ' ';
				break;
			case '%':
				if (k < num2 - 2)
				{
					int num3 = d(A_0, k + 1, 2);
					if (num3 != -1)
					{
						c2 = (char)num3;
						k += 2;
					}
				}
				break;
			}
			memoryStream.WriteByte((byte)c2);
		}
		return memoryStream.ToArray();
	}

	public static string h(string A_0)
	{
		return c(A_0, Encoding.UTF8);
	}

	public static string c(string A_0, Encoding A_1)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_0 == string.Empty)
		{
			return string.Empty;
		}
		bool flag = false;
		int length = A_0.Length;
		for (int k = 0; k < length; k++)
		{
			char c2 = A_0[k];
			if ((c2 < '0' || (c2 < 'A' && c2 > '9') || (c2 > 'Z' && c2 < 'a') || c2 > 'z') && !Com.Raritan.KxGui.Helpers.i.a(c2))
			{
				flag = true;
				break;
			}
		}
		if (!flag)
		{
			return A_0;
		}
		byte[] array = new byte[A_1.GetMaxByteCount(A_0.Length)];
		int bytes = A_1.GetBytes(A_0, 0, A_0.Length, array, 0);
		return Encoding.ASCII.GetString(a(array, 0, bytes));
	}

	public static string b(byte[] A_0)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_0.Length == 0)
		{
			return string.Empty;
		}
		return Encoding.ASCII.GetString(a(A_0, 0, A_0.Length));
	}

	public static string b(byte[] A_0, int A_1, int A_2)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_0.Length == 0)
		{
			return string.Empty;
		}
		return Encoding.ASCII.GetString(a(A_0, A_1, A_2));
	}

	public static byte[] g(string A_0)
	{
		return b(A_0, Encoding.UTF8);
	}

	public static byte[] b(string A_0, Encoding A_1)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_0.Length == 0)
		{
			return new byte[0];
		}
		byte[] bytes = A_1.GetBytes(A_0);
		return a(bytes, 0, bytes.Length);
	}

	public static byte[] a(byte[] A_0)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_0.Length == 0)
		{
			return new byte[0];
		}
		return a(A_0, 0, A_0.Length);
	}

	public static byte[] a(byte[] A_0, int A_1, int A_2)
	{
		if (A_0 == null)
		{
			return null;
		}
		return Com.Raritan.KxGui.Helpers.i.a(A_0, A_1, A_2);
	}

	public static string f(string A_0)
	{
		if (A_0 == null)
		{
			return null;
		}
		return Encoding.ASCII.GetString(e(A_0));
	}

	public static byte[] e(string A_0)
	{
		if (A_0 == null)
		{
			return null;
		}
		if (A_0.Length == 0)
		{
			return new byte[0];
		}
		MemoryStream memoryStream = new MemoryStream(A_0.Length);
		foreach (char a_ in A_0)
		{
			Com.Raritan.KxGui.Helpers.i.a(a_, memoryStream, A_2: true);
		}
		return memoryStream.ToArray();
	}

	public static string d(string A_0)
	{
		return Com.Raritan.KxGui.Helpers.i.a(A_0);
	}

	public static void b(string A_0, TextWriter A_1)
	{
		if (A_1 == null)
		{
			throw new NullReferenceException(".NET emulation");
		}
		if (!string.IsNullOrEmpty(A_0))
		{
			A_1.Write(Com.Raritan.KxGui.Helpers.i.a(A_0));
		}
	}

	public static string c(string A_0)
	{
		return Com.Raritan.KxGui.Helpers.i.c(A_0);
	}

	public static void a(string A_0, TextWriter A_1)
	{
		if (A_1 == null)
		{
			throw new NullReferenceException(".NET emulation");
		}
		if (!string.IsNullOrEmpty(A_0))
		{
			A_1.Write(Com.Raritan.KxGui.Helpers.i.c(A_0));
		}
	}

	public static string b(string A_0)
	{
		return Com.Raritan.KxGui.Helpers.i.d(A_0);
	}

	public static NameValueCollection a(string A_0)
	{
		return a(A_0, Encoding.UTF8);
	}

	public static NameValueCollection a(string A_0, Encoding A_1)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("query");
		}
		if (A_1 == null)
		{
			throw new ArgumentNullException("encoding");
		}
		if (A_0.Length == 0 || (A_0.Length == 1 && A_0[0] == '?'))
		{
			return new NameValueCollection();
		}
		if (A_0[0] == '?')
		{
			A_0 = A_0.Substring(1);
		}
		NameValueCollection nameValueCollection = new a();
		a(A_0, A_1, nameValueCollection);
		return nameValueCollection;
	}

	internal static void a(string A_0, Encoding A_1, NameValueCollection A_2)
	{
		if (A_0.Length == 0)
		{
			return;
		}
		string text = d(A_0);
		int length = text.Length;
		int num = 0;
		bool flag = true;
		while (num <= length)
		{
			int num2 = -1;
			int num3 = -1;
			for (int k = num; k < length; k++)
			{
				if (num2 == -1 && text[k] == '=')
				{
					num2 = k + 1;
				}
				else if (text[k] == '&')
				{
					num3 = k;
					break;
				}
			}
			if (flag)
			{
				flag = false;
				if (text[num] == '?')
				{
					num++;
				}
			}
			string name;
			if (num2 == -1)
			{
				name = null;
				num2 = num;
			}
			else
			{
				name = e(text.Substring(num, num2 - num - 1), A_1);
			}
			if (num3 < 0)
			{
				num = -1;
				num3 = text.Length;
			}
			else
			{
				num = num3 + 1;
			}
			string value = e(text.Substring(num2, num3 - num2), A_1);
			A_2.Add(name, value);
			if (num == -1)
			{
				break;
			}
		}
	}
}
