using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Drawing;
using System.IO;
using System.Net;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using Com.Raritan.KxGui.Helpers;
using Com.Raritan.RcCore;
using log4net;

namespace Com.Raritan.KxGui;

internal static class e
{
	private const string m_a = "title_app.asp";

	private static ILog m_b = LogManager.GetLogger(typeof(e));

	internal static string c = "Device.HostName";

	internal static string d = "Device.IPAddress";

	internal static string e = "Device.SessionID";

	internal static string f = "Device.SessionKey";

	internal static string g = "Device.TCPPort";

	internal static string h = "Device.VirtualMedia";

	internal static string i = "Device.Access";

	internal static string j = "Device.ConnectionID";

	internal static string k = "Device.ConnectionIDHTTPS";

	internal static string l = "Device.Name";

	internal static string m = "Device.Model";

	internal static string n = "Device.useSSLInProxy";

	internal static string ad = "Device.MultiMonitorLaunch";

	internal static string v = "PortCount";

	internal static string o = "Port.Type";

	internal static string p = "Port.Class";

	internal static string q = "Port.ID";

	internal static string r = "Port.Name";

	internal static string w = "Port.MonitorIndex";

	internal static string x = "Port.MonitorHPosition";

	internal static string y = "Port.MonitorVPosition";

	internal static string z = "Port.SessionID";

	internal static string aa = "Port.SessionKey";

	internal static string ab = "Port.ConnectionID";

	internal static string ac = "Port.ConnectionIDHTTPS";

	private static string s = "param name=\"SSL\"";

	private static string t = "value=\"";

	private static string u = "\"";

	[CompilerGenerated]
	private static bool ae;

	[SpecialName]
	[CompilerGenerated]
	internal static bool a()
	{
		return ae;
	}

	[SpecialName]
	[CompilerGenerated]
	private static void a(bool A_0)
	{
		ae = A_0;
	}

	internal static Dictionary<string, string> b(string A_0)
	{
		//IL_0006: Unknown result type (might be due to invalid IL or missing references)
		//IL_000c: Expected O, but got Unknown
		//IL_0016: Expected O, but got Unknown
		//IL_0053: Unknown result type (might be due to invalid IL or missing references)
		//IL_005a: Expected O, but got Unknown
		//IL_010e: Unknown result type (might be due to invalid IL or missing references)
		//IL_0115: Expected O, but got Unknown
		Dictionary<string, string> dictionary = new Dictionary<string, string>();
		XmlDocument val = new XmlDocument();
		try
		{
			val.LoadXml(A_0);
		}
		catch (XmlException val2)
		{
			XmlException exception = val2;
			Com.Raritan.KxGui.e.m_b.Error("Error parsing ccsg connection params", (Exception)(object)exception);
			return null;
		}
		XmlNode val3 = ((XmlNode)val).SelectSingleNode("CSC_Info/Device");
		if (val3 != null)
		{
			foreach (XmlAttribute item in (XmlNamedNodeMap)val3.Attributes)
			{
				XmlAttribute val4 = item;
				dictionary.Add("Device." + ((XmlNode)val4).Name, ((XmlNode)val4).Value);
			}
		}
		XmlNodeList val5 = ((XmlNode)val).SelectNodes("CSC_Info/Port");
		if (val5 != null)
		{
			dictionary.Add(v, string.Concat(val5.Count));
			for (int num = 0; num < val5.Count; num++)
			{
				val3 = val5[num];
				string text = ((num == 0) ? "" : ("." + num));
				foreach (XmlAttribute item2 in (XmlNamedNodeMap)val3.Attributes)
				{
					XmlAttribute val6 = item2;
					dictionary.Add("Port." + ((XmlNode)val6).Name + text, ((XmlNode)val6).Value);
				}
				val3 = val3.SelectSingleNode("Name");
				if (val3 != null)
				{
					dictionary.Add(r + text, val3.InnerText);
				}
			}
		}
		return dictionary;
	}

	internal static string a(long A_0)
	{
		StringBuilder stringBuilder = new StringBuilder();
		stringBuilder.Append((A_0 >> 24) & 0xFF);
		stringBuilder.Append('.');
		stringBuilder.Append((A_0 >> 16) & 0xFF);
		stringBuilder.Append('.');
		stringBuilder.Append((A_0 >> 8) & 0xFF);
		stringBuilder.Append('.');
		stringBuilder.Append(A_0 & 0xFF);
		return stringBuilder.ToString();
	}

	internal static bool a(string A_0)
	{
		StringReader stringReader = new StringReader(A_0);
		for (string text = stringReader.ReadLine(); text != null; text = stringReader.ReadLine())
		{
			if (text.Contains(s))
			{
				int num = text.IndexOf(t);
				if (num != -1)
				{
					num += t.Length;
					if (num < text.Length)
					{
						int num2 = text.IndexOf(u, num);
						if (num2 != -1)
						{
							string value = text.Substring(num, num2 - num);
							return "force".Equals(value);
						}
					}
				}
			}
		}
		throw new Exception("Unable to fetch the SSL parameter");
	}

	private static bool c(string A_0)
	{
		if (!"vm".Equals(A_0, StringComparison.OrdinalIgnoreCase) && !"dual-vm".Equals(A_0, StringComparison.OrdinalIgnoreCase) && !"vkp-vm".Equals(A_0, StringComparison.OrdinalIgnoreCase))
		{
			return "kvm".Equals(A_0, StringComparison.OrdinalIgnoreCase);
		}
		return true;
	}

	internal static void a(NameValueCollection A_0, l A_1, out Com.Raritan.RcCore.a A_2, out a A_3)
	{
		string text = A_0["url"];
		if (text == null)
		{
			string text2 = A_0["link2"];
			string text4;
			try
			{
				string text3 = Path.Combine(Path.GetTempPath(), text2);
				text4 = File.ReadAllText(text3);
				try
				{
					File.Delete(text3);
				}
				catch (Exception exception)
				{
					Com.Raritan.KxGui.e.m_b.Warn("Failed to delete file " + text3, exception);
				}
			}
			catch (Exception ex)
			{
				string text5 = "Exception on reading the file : " + text2 + " in " + Path.GetTempPath();
				Com.Raritan.KxGui.e.m_b.Error(text5, ex);
				throw new g.c(text5, ex, Com.Raritan.KxGui.g.f.u);
			}
			if (text4.StartsWith("url="))
			{
				text = text4.Substring(4);
				text = Com.Raritan.KxGui.Helpers.j.e(text, Encoding.UTF8);
			}
		}
		Uri uri;
		try
		{
			uri = new Uri(text);
		}
		catch (Exception ex2)
		{
			string text6 = "Exception on parsing the url";
			Com.Raritan.KxGui.e.m_b.Error(text6, ex2);
			throw new g.c(text6, ex2, Com.Raritan.KxGui.g.f.b);
		}
		Com.Raritan.KxGui.e.m_b.Debug("Performing a HTPPS Get on " + uri);
		string text7;
		try
		{
			text7 = A_1.a(uri, null);
		}
		catch (TimeoutException ex3)
		{
			string text8 = "Timeout occured on connecting to CCSG";
			Com.Raritan.KxGui.e.m_b.Error(text8, ex3);
			throw new g.c(text8, ex3, Com.Raritan.KxGui.g.f.c);
		}
		catch (Exception ex4)
		{
			string text9 = "Exception occured on connecting to CCSG";
			Com.Raritan.KxGui.e.m_b.Error(text9, ex4);
			throw new g.c(text9, ex4, Com.Raritan.KxGui.g.f.d);
		}
		if (text7 == null)
		{
			string text10 = "Failed to GETResponse from CCSG";
			Com.Raritan.KxGui.e.m_b.Error(text10);
			throw new g.c(text10, Com.Raritan.KxGui.g.f.d);
		}
		Com.Raritan.KxGui.e.m_b.Debug("HTTPSGetResponse : " + text7);
		Dictionary<string, string> dictionary = b(text7);
		if (dictionary == null)
		{
			string text11 = "Failed to Parse the connection data provided by CCSG";
			Com.Raritan.KxGui.e.m_b.Error(text11);
			throw new g.c(text11, Com.Raritan.KxGui.g.f.e);
		}
		Com.Raritan.KxGui.e.m_b.Debug("CSCInfo params from CCSG");
		foreach (KeyValuePair<string, string> item in dictionary)
		{
			Com.Raritan.KxGui.e.m_b.Debug("Param - " + item.Key + " : " + item.Value);
		}
		Com.Raritan.RcCore.a.a a2 = Com.Raritan.RcCore.a.a.c;
		if (dictionary.ContainsKey(i))
		{
			string value = dictionary[i];
			a2 = ("Control".Equals(value, StringComparison.InvariantCultureIgnoreCase) ? Com.Raritan.RcCore.a.a.c : ("View".Equals(value, StringComparison.InvariantCultureIgnoreCase) ? Com.Raritan.RcCore.a.a.b : Com.Raritan.RcCore.a.a.a));
		}
		Com.Raritan.RcCore.a.b b2 = Com.Raritan.RcCore.a.b.a;
		if (dictionary.ContainsKey(h))
		{
			string value2 = dictionary[h];
			if ("read-write".Equals(value2, StringComparison.InvariantCultureIgnoreCase))
			{
				b2 = Com.Raritan.RcCore.a.b.c;
			}
			else if ("read-only".Equals(value2, StringComparison.InvariantCultureIgnoreCase))
			{
				b2 = Com.Raritan.RcCore.a.b.b;
			}
		}
		string text12 = null;
		if (dictionary.ContainsKey(Com.Raritan.KxGui.e.c))
		{
			string a_ = dictionary[Com.Raritan.KxGui.e.c];
			text12 = d(a_);
		}
		else
		{
			if (!dictionary.ContainsKey(Com.Raritan.KxGui.e.d))
			{
				string text13 = "Missing IPAddress attribute in Device Element";
				Com.Raritan.KxGui.e.m_b.Error(text13);
				throw new g.c(text13, Com.Raritan.KxGui.g.f.h);
			}
			text12 = dictionary[Com.Raritan.KxGui.e.d];
			try
			{
				long a_2 = long.Parse(text12);
				text12 = a(a_2);
			}
			catch (Exception ex5)
			{
				string text14 = "Failed to parse the IPAddress";
				Com.Raritan.KxGui.e.m_b.Error(text14, ex5);
				throw new g.c(text14, ex5, Com.Raritan.KxGui.g.f.g);
			}
		}
		if (!dictionary.TryGetValue(v, out var value3) || !int.TryParse(value3, out var result) || result <= 0)
		{
			string text15 = "Missing port count attribute in Port Element";
			Com.Raritan.KxGui.e.m_b.Error(text15);
			throw new g.c(text15, Com.Raritan.KxGui.g.f.i);
		}
		Dictionary<string, string> dictionary2 = new Dictionary<string, string>();
		Dictionary<string, string> dictionary3 = new Dictionary<string, string>();
		Dictionary<string, string> dictionary4 = new Dictionary<string, string>();
		if (!dictionary.TryGetValue(e, out var value4))
		{
			string text16 = "Missing SessionID attribute in Device Element";
			Com.Raritan.KxGui.e.m_b.Error(text16);
			throw new g.c(text16, Com.Raritan.KxGui.g.f.j);
		}
		if (!dictionary.TryGetValue(f, out var value5))
		{
			string text17 = "Missing SessionKey attribute in Device Element";
			Com.Raritan.KxGui.e.m_b.Error(text17);
			throw new g.c(text17, Com.Raritan.KxGui.g.f.k);
		}
		string a_3 = "\"" + value4 + "\":\"" + value5 + "\"";
		dictionary.TryGetValue(j, out var value6);
		dictionary.TryGetValue(k, out var value7);
		dictionary.TryGetValue(n, out var value8);
		if (dictionary.TryGetValue(ad, out var value9) && !string.IsNullOrEmpty(value9))
		{
			a(value9.ToLower().Equals("true"));
		}
		else
		{
			a(A_0: false);
		}
		if (result == 1)
		{
			if (!dictionary.TryGetValue(q, out var value10))
			{
				string text18 = "Missing ID attribute in Port Element";
				Com.Raritan.KxGui.e.m_b.Error(text18);
				throw new g.c(text18, Com.Raritan.KxGui.g.f.i);
			}
			if (!dictionary.TryGetValue(r, out var value11))
			{
				value11 = "";
			}
			string value12 = null;
			dictionary.TryGetValue(o, out value12);
			A_2 = new Com.Raritan.RcCore.a(string.Concat(0), value10, value11, a2, b2, c(value12));
		}
		else
		{
			int num = -1;
			string[] array = new string[result];
			string[] array2 = new string[result];
			string[] array3 = new string[result];
			int[] array4 = new int[result];
			int[] array5 = new int[result];
			int[] array6 = new int[result];
			for (int num2 = 0; num2 < result; num2++)
			{
				string text19 = ((num2 == 0) ? "" : ("." + num2));
				if (!dictionary.TryGetValue(q + text19, out array[num2]))
				{
					string text20 = "Missing ID attribute in Port Element";
					Com.Raritan.KxGui.e.m_b.Error(text20);
					throw new g.c(text20, Com.Raritan.KxGui.g.f.i);
				}
				if (!dictionary.TryGetValue(r + text19, out array2[num2]))
				{
					array2[num2] = "";
				}
				dictionary.TryGetValue(o + text19, out array3[num2]);
				if (!dictionary.TryGetValue(w + text19, out var value13) || !int.TryParse(value13, out array4[num2]))
				{
					array4[num2] = 0;
				}
				if (!dictionary.TryGetValue(x + text19, out value13) || !int.TryParse(value13, out array5[num2]))
				{
					array5[num2] = 0;
				}
				if (!dictionary.TryGetValue(y + text19, out value13) || !int.TryParse(value13, out array6[num2]))
				{
					array6[num2] = 0;
				}
				if (!dictionary.TryGetValue(z + text19, out var value14))
				{
					string text21 = "Missing SessionID attribute in Port Element";
					Com.Raritan.KxGui.e.m_b.Error(text21);
					throw new g.c(text21, Com.Raritan.KxGui.g.f.j);
				}
				if (!dictionary.TryGetValue(aa + text19, out var value15))
				{
					string text22 = "Missing SessionKey attribute in Port Element";
					Com.Raritan.KxGui.e.m_b.Error(text22);
					throw new g.c(text22, Com.Raritan.KxGui.g.f.k);
				}
				dictionary.TryGetValue(ab + text19, out var value16);
				dictionary.TryGetValue(ac + text19, out var value17);
				string value18 = "\"" + value14 + "\":\"" + value15 + "\"";
				dictionary2[array[num2]] = value18;
				dictionary3[array[num2]] = value16 ?? value6;
				dictionary4[array[num2]] = value17 ?? value7;
				if (array4[num2] == 0)
				{
					if (num != -1)
					{
						string text23 = "Duplicate primary port";
						Com.Raritan.KxGui.e.m_b.Error(text23);
						throw new g.c(text23, Com.Raritan.KxGui.g.f.i);
					}
					num = num2;
				}
			}
			if (num == -1)
			{
				string text24 = "No primary port";
				Com.Raritan.KxGui.e.m_b.Error(text24);
				throw new g.c(text24, Com.Raritan.KxGui.g.f.i);
			}
			aj aj2 = (aj)(A_2 = new aj(string.Concat(num), array[num], array2[num], a2, b2, c(array3[num]), array4[num], new Point(array5[num], array6[num])));
			for (int num3 = 0; num3 < result; num3++)
			{
				if (num3 != num)
				{
					aj2.i().Add(new ai(aj2, string.Concat(num3), array[num3], array2[num3], a2, b2, c(array3[num3]), array4[num3], new Point(array5[num3], array6[num3])));
				}
			}
		}
		int num4 = 443;
		if (dictionary.TryGetValue(g, out var value19))
		{
			try
			{
				num4 = int.Parse(value19);
			}
			catch (Exception ex6)
			{
				string text25 = "Failed to parse the TCPPort";
				Com.Raritan.KxGui.e.m_b.Error(text25, ex6);
				throw new g.c(text25, ex6, Com.Raritan.KxGui.g.f.l);
			}
		}
		bool a_4 = false;
		if (value6 == null)
		{
			Uri uri2 = new Uri("https://" + Com.Raritan.KxGui.l.a(text12) + ":" + num4 + "/title_app.asp");
			Dictionary<string, string> dictionary5 = new Dictionary<string, string>();
			string text26 = value4 + ":" + value5;
			dictionary5["Authorization"] = "Basic " + Convert.ToBase64String(Encoding.UTF8.GetBytes(text26));
			Com.Raritan.KxGui.e.m_b.Debug("Performing a HTPPS Get on " + uri2);
			string text27;
			try
			{
				text27 = A_1.a(uri2, dictionary5);
			}
			catch (TimeoutException ex7)
			{
				string text28 = "Timeout occured on connecting to KX";
				Com.Raritan.KxGui.e.m_b.Error(text28, ex7);
				throw new g.c(text28, ex7, Com.Raritan.KxGui.g.f.m);
			}
			catch (Exception ex8)
			{
				string text29 = "Exception occured on connecting to KX";
				Com.Raritan.KxGui.e.m_b.Error(text29, ex8);
				throw new g.c(text29, ex8, Com.Raritan.KxGui.g.f.n);
			}
			Com.Raritan.KxGui.e.m_b.Debug("HTTPSGetResponse : " + text27);
			if (text27 == null)
			{
				string text30 = "Failed to Retrieve the title_app.aspfrom device";
				Com.Raritan.KxGui.e.m_b.Error(text30);
				throw new g.c(text30, Com.Raritan.KxGui.g.f.m);
			}
			try
			{
				a_4 = a(text27);
			}
			catch (Exception ex9)
			{
				string text31 = "Failed to parse SSL param received from device";
				Com.Raritan.KxGui.e.m_b.Error(text31, ex9);
				throw new g.c(text31, ex9, Com.Raritan.KxGui.g.f.o);
			}
		}
		A_3 = new a(text12, num4, a_4, null, a_3, dictionary2, value6, dictionary3, value7, dictionary4, value8);
	}

	private static string d(string A_0)
	{
		string text = null;
		if (A_0.Length != 0)
		{
			try
			{
				IPAddress[] hostAddresses = Dns.GetHostAddresses(A_0);
				if (hostAddresses.Length > 0)
				{
					text = hostAddresses[0].ToString();
				}
			}
			catch (Exception ex)
			{
				string text2 = "Failed to resolve the hostname " + A_0;
				Com.Raritan.KxGui.e.m_b.Error(text2, ex);
				throw new g.c(text2, ex, Com.Raritan.KxGui.g.f.f);
			}
		}
		if (text == null)
		{
			string text3 = "Failed to resolve the hostname " + A_0;
			Com.Raritan.KxGui.e.m_b.Error(text3);
			throw new g.c(text3, Com.Raritan.KxGui.g.f.f);
		}
		return text;
	}
}
