using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Runtime.CompilerServices;
using System.Threading;
using System.Windows.Forms;
using log4net;

namespace Com.Raritan.KxGui;

internal static class q
{
	[CompilerGenerated]
	private sealed class b
	{
		public aa a;
	}

	[CompilerGenerated]
	private sealed class a
	{
		public b a;

		public string b;

		public void a(object A_0, WebBrowserDocumentCompletedEventArgs A_1)
		{
			//IL_0001: Unknown result type (might be due to invalid IL or missing references)
			//IL_0029: Unknown result type (might be due to invalid IL or missing references)
			//IL_002f: Expected O, but got Unknown
			HtmlDocument document = ((WebBrowser)A_0).Document;
			HtmlElementCollection elementsByTagName = document.GetElementsByTagName("img");
			foreach (HtmlElement item in elementsByTagName)
			{
				HtmlElement val = item;
				string text = null;
				try
				{
					text = val.GetAttribute("src");
					if (!string.IsNullOrEmpty(text))
					{
						Uri uri = new Uri(text);
						q.a(uri.LocalPath);
					}
				}
				catch (Exception exception)
				{
					q.m_a.Error("Failed to get Image Information for " + text, exception);
				}
			}
			q.a(b, this.a.a);
		}
	}

	private static readonly ILog m_a = LogManager.GetLogger(typeof(q));

	private static bool m_b;

	private static string m_c;

	private static string m_d;

	private static string m_e;

	private static d f;

	private static aa g;

	private static string e()
	{
		string text = null;
		int num = 0;
		while (num++ < 5)
		{
			string text2 = Path.Combine(Path.GetTempPath(), Path.GetRandomFileName());
			if (!Directory.Exists(text2))
			{
				text2 = Path.Combine(text2, Thread.CurrentThread.CurrentCulture.Name);
				try
				{
					Directory.CreateDirectory(text2);
				}
				catch (Exception exception)
				{
					q.m_a.Error("Failed to create " + text2, exception);
					return null;
				}
				text = text2;
				break;
			}
		}
		if (text == null)
		{
			q.m_a.Error("Failed to create a unique Temp Directory to store Help Files");
			return null;
		}
		return text;
	}

	private static string d()
	{
		if (q.m_c != null)
		{
			string text = Path.Combine(q.m_c, "help");
			try
			{
				Directory.CreateDirectory(text);
				return text;
			}
			catch (Exception exception)
			{
				q.m_a.Error("Failed to create " + text, exception);
			}
		}
		return null;
	}

	private static string c()
	{
		if (q.m_c != null)
		{
			string text = Path.Combine(q.m_c, "icons");
			try
			{
				Directory.CreateDirectory(text);
				return text;
			}
			catch (Exception exception)
			{
				q.m_a.Error("Failed to create " + text, exception);
			}
		}
		return null;
	}

	internal static void b(string A_0, aa A_1)
	{
		//IL_00db: Unknown result type (might be due to invalid IL or missing references)
		//IL_00e1: Expected O, but got Unknown
		//IL_00ed: Unknown result type (might be due to invalid IL or missing references)
		//IL_00f3: Expected O, but got Unknown
		if (!q.m_b)
		{
			q.m_c = e();
			q.m_d = d();
			q.m_e = c();
			q.m_b = true;
		}
		if (q.m_d == null || q.m_e == null)
		{
			return;
		}
		WebBrowserDocumentCompletedEventHandler val = null;
		string b2 = Path.Combine(q.m_d, A_0);
		if (!File.Exists(b2))
		{
			if (KxGuiResources.ResourceManager.GetObject(A_0) is byte[] bytes)
			{
				try
				{
					File.WriteAllBytes(b2, bytes);
				}
				catch (Exception exception)
				{
					q.m_a.Error("Failed to Write HelpFile to " + b2, exception);
					return;
				}
				WebBrowser val2 = new WebBrowser();
				if (val == null)
				{
					val = (WebBrowserDocumentCompletedEventHandler)delegate(object A_0, WebBrowserDocumentCompletedEventArgs A_1)
					{
						//IL_0001: Unknown result type (might be due to invalid IL or missing references)
						//IL_0029: Unknown result type (might be due to invalid IL or missing references)
						//IL_002f: Expected O, but got Unknown
						HtmlDocument document = ((WebBrowser)A_0).Document;
						HtmlElementCollection elementsByTagName = document.GetElementsByTagName("img");
						foreach (HtmlElement item in elementsByTagName)
						{
							HtmlElement val3 = item;
							string text = null;
							try
							{
								text = val3.GetAttribute("src");
								if (!string.IsNullOrEmpty(text))
								{
									Uri uri = new Uri(text);
									a(uri.LocalPath);
								}
							}
							catch (Exception exception2)
							{
								q.m_a.Error("Failed to get Image Information for " + text, exception2);
							}
						}
						a(b2, A_1);
					};
				}
				val2.DocumentCompleted += val;
				val2.Url = new Uri(b2);
			}
			else
			{
				q.m_a.Error("Resource unavailable " + A_0);
			}
		}
		else
		{
			a(b2, A_1);
		}
	}

	private static bool a(string A_0)
	{
		FileInfo fileInfo = new FileInfo(A_0);
		string text = fileInfo.Name.Substring(0, fileInfo.Name.IndexOf(fileInfo.Extension));
		string text2 = "img_" + text;
		object? @object = KxGuiResources.ResourceManager.GetObject(text2);
		Bitmap val = (Bitmap)((@object is Bitmap) ? @object : null);
		if (val != null)
		{
			try
			{
				((Image)val).Save(A_0, ImageFormat.Gif);
			}
			catch (Exception exception)
			{
				q.m_a.Error("Failed to Write Icons to " + A_0, exception);
				return false;
			}
			return true;
		}
		q.m_a.Error("Resource unavailable " + text2);
		return false;
	}

	private static void a(string A_0, aa A_1)
	{
		//IL_0117: Unknown result type (might be due to invalid IL or missing references)
		if (f == null)
		{
			f = new d(new Uri(A_0), A_1.a());
			g = A_1;
			((Form)f).TopMost = A_1.b();
			((Form)f).Closing += a;
			A_1.add_Disposed(a);
			A_1.a(a);
		}
		else
		{
			if (g != A_1)
			{
				if (g != null)
				{
					g.remove_Disposed(a);
					g.b(a);
				}
				g = A_1;
				g.add_Disposed(a);
				g.a(a);
				a(g.a());
			}
			((Form)f).TopMost = g.b();
			f.a(new Uri(A_0));
			if (((object)((Form)f).WindowState).Equals((object)(FormWindowState)1))
			{
				if (u.a((Form)(object)f))
				{
					((Form)f).WindowState = (FormWindowState)2;
				}
				else
				{
					((Form)f).WindowState = (FormWindowState)0;
				}
			}
		}
		((Control)f).Show();
	}

	private static void a(bool A_0)
	{
		if (!A_0)
		{
			((Form)f).TopMost = false;
		}
	}

	private static void a(object A_0, EventArgs A_1)
	{
		g.remove_Disposed(a);
		g.b(a);
		g = null;
		((Control)f).Visible = false;
	}

	private static void a(object A_0, CancelEventArgs A_1)
	{
		A_1.Cancel = true;
		((Control)f).Visible = false;
	}

	internal static void b()
	{
		if (f != null)
		{
			u.a("Software\\App\\Raritan\\RAKC\\helpwindow", (Form)(object)f);
		}
		if (q.m_c != null)
		{
			try
			{
				Directory.Delete(q.m_c, recursive: true);
			}
			catch (Exception exception)
			{
				q.m_a.Warn("Unable to delete the temp help directory " + q.m_c, exception);
			}
		}
	}

	private static void a(Control A_0)
	{
		int num = A_0.Location.X + (A_0.Width - ((Control)f).Width) / 2;
		int num2 = A_0.Location.Y + (A_0.Height - ((Control)f).Height) / 2;
		((Form)f).Location = new Point(num, num2);
	}
}
