﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">
    <DevicePreferences>
      <DeviceIp>
        <xsl:value-of select="node/@name"/>
      </DeviceIp>
      <xsl:apply-templates select="node/map/entry[@key='g2ConnectionSpeed']"/>
      <xsl:apply-templates select="node/map/entry[@key='g2Smoothing']"/>
      <xsl:apply-templates select="node/map/entry[@key='g2ColorDepth']"/>
      <xsl:apply-templates select="node/map/entry[@key='autoMountSmartCardReaderName']"/>
      <xsl:apply-templates select="node/map/entry[@key='ipAddress']"/>
      <xsl:apply-templates select="node/map/entry[@key='description']"/>
      <xsl:apply-templates select="node/map/entry[@key='dnsName']"/>
      <xsl:apply-templates select="node/map/entry[@key='productType']"/>
      <xsl:apply-templates select="node/map/entry[@key='port']"/>
      <xsl:apply-templates select="node/map/entry[@key='connectPlaybackDevice']"/>
      <xsl:apply-templates select="node/map/entry[@key='playbackDevice']"/>
      <xsl:apply-templates select="node/map/entry[@key='playbackFormat']"/>
      <xsl:apply-templates select="node/map/entry[@key='playbackBufferSize']"/>
      <xsl:apply-templates select="node/map/entry[@key='connectCaptureDevice']"/>
      <xsl:apply-templates select="node/map/entry[@key='captureDevice']"/>
      <xsl:apply-templates select="node/map/entry[@key='captureFormat']"/>
      <xsl:apply-templates select="node/map/entry[@key='captureBufferSize']"/>
    </DevicePreferences>
  </xsl:template>

  <xsl:template match="node/map/entry[@key='g2ConnectionSpeed']">
    <ConnectionSpeed>
      <xsl:value-of select="@value"/>
    </ConnectionSpeed>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='g2Smoothing']">
    <Smoothing>
      <xsl:value-of select="@value"/>
    </Smoothing>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='g2ColorDepth']">
    <ColorDepth>
      <xsl:value-of select="@value"/>
    </ColorDepth>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='autoMountSmartCardReaderName']">
    <SmartCardReaderName>
      <xsl:value-of select="@value"/>
    </SmartCardReaderName>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='ipAddress']">
    <IpAddress>
      <xsl:value-of select="@value"/>
    </IpAddress>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='description']">
    <Description>
      <xsl:value-of select="@value"/>
    </Description>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='dnsName']">
    <DnsName>
      <xsl:value-of select="@value"/>
    </DnsName> 
  </xsl:template>
  <xsl:template match="node/map/entry[@key='productType']">
    <ProductType>
      <xsl:value-of select="@value"/>
    </ProductType>  
  </xsl:template>
  <xsl:template match="node/map/entry[@key='port']">
    <Port>
      <xsl:value-of select="@value"/>
    </Port>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='connectPlaybackDevice']">
    <ConnectPlaybackDevice>
      <xsl:value-of select="@value"/>
    </ConnectPlaybackDevice>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='playbackDevice']">
    <PlaybackDevice>
      <xsl:value-of select="@value"/>
    </PlaybackDevice>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='playbackFormat']">
    <PlaybackFormat>
      <xsl:value-of select="@value"/>
    </PlaybackFormat>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='playbackBufferSize']">
    <PlaybackBufferSize>
      <xsl:value-of select="@value"/>
    </PlaybackBufferSize>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='connectCaptureDevice']">
    <ConnectCaptureDevice>
      <xsl:value-of select="@value"/>
    </ConnectCaptureDevice>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='captureDevice']">
    <CaptureDevice>
      <xsl:value-of select="@value"/>
    </CaptureDevice>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='captureFormat']">
    <CaptureFormat>
      <xsl:value-of select="@value"/>
    </CaptureFormat>
  </xsl:template>
  <xsl:template match="node/map/entry[@key='captureBufferSize']">
    <CaptureBufferSize>
      <xsl:value-of select="@value"/>
    </CaptureBufferSize>
  </xsl:template>
</xsl:stylesheet>
