using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using Com.Raritan.Core;
using Com.Raritan.VmCore.Impl.App;
using Com.Raritan.VmCore.Impl.Lsp;
using Com.Raritan.VmCore.Impl.Media;
using log4net;

namespace Com.Raritan.VmCore.Impl;

public class b : Com.Raritan.VmCore.c
{
	private abstract class a
	{
		protected const string a = "csharp_DriveEnumerator_enumerateNative";

		protected const string b = "csharp_DriveEnumerator_releaseEnumeration";

		protected const string c = "csharp_DriveEnumerator_getNativePtr";

		protected const string d = "csharp_DriveEnumerator_getNativeName";

		protected const string e = "csharp_DriveEnumerator_getNativeType";

		internal abstract IntPtr a(bool A_0);

		internal abstract void a(IntPtr A_0);

		internal abstract IntPtr a(IntPtr A_0, int A_1);

		internal abstract string b(IntPtr A_0, int A_1);

		internal abstract int c(IntPtr A_0, int A_1);
	}

	private class b : a
	{
		private new const string m_a = "DrvRedirNative2.dll";

		[DllImport("DrvRedirNative2.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_enumerateNative")]
		private new static extern IntPtr b(bool A_0);

		[DllImport("DrvRedirNative2.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_releaseEnumeration")]
		private new static extern void b(IntPtr A_0);

		[DllImport("DrvRedirNative2.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_getNativePtr")]
		private static extern IntPtr f(IntPtr A_0, int A_1);

		[DllImport("DrvRedirNative2.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_getNativeName")]
		private new static extern IntPtr e(IntPtr A_0, int A_1);

		[DllImport("DrvRedirNative2.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_getNativeType")]
		private new static extern int d(IntPtr A_0, int A_1);

		internal override IntPtr a(bool A_0)
		{
			return b(A_0);
		}

		internal override void a(IntPtr A_0)
		{
			b(A_0);
		}

		internal override IntPtr a(IntPtr A_0, int A_1)
		{
			return f(A_0, A_1);
		}

		internal override string b(IntPtr A_0, int A_1)
		{
			return Marshal.PtrToStringAnsi(e(A_0, A_1));
		}

		internal override int c(IntPtr A_0, int A_1)
		{
			return d(A_0, A_1);
		}
	}

	private class c : a
	{
		private new const string m_a = "DrvRedirNative2_x64.dll";

		[DllImport("DrvRedirNative2_x64.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_enumerateNative")]
		private new static extern IntPtr b(bool A_0);

		[DllImport("DrvRedirNative2_x64.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_releaseEnumeration")]
		private new static extern void b(IntPtr A_0);

		[DllImport("DrvRedirNative2_x64.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_getNativePtr")]
		private static extern IntPtr f(IntPtr A_0, int A_1);

		[DllImport("DrvRedirNative2_x64.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_getNativeName")]
		private new static extern IntPtr e(IntPtr A_0, int A_1);

		[DllImport("DrvRedirNative2_x64.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "csharp_DriveEnumerator_getNativeType")]
		private new static extern int d(IntPtr A_0, int A_1);

		internal override IntPtr a(bool A_0)
		{
			return b(A_0);
		}

		internal override void a(IntPtr A_0)
		{
			b(A_0);
		}

		internal override IntPtr a(IntPtr A_0, int A_1)
		{
			return f(A_0, A_1);
		}

		internal override string b(IntPtr A_0, int A_1)
		{
			return Marshal.PtrToStringAnsi(e(A_0, A_1));
		}

		internal override int c(IntPtr A_0, int A_1)
		{
			return d(A_0, A_1);
		}
	}

	private const int m_a = 0;

	private const int m_b = 1;

	private const int m_c = 2;

	private const int d = 3;

	private const int n = 4;

	private const int o = 5;

	private const int e = -1;

	private ILog f;

	private IntPtr g = IntPtr.Zero;

	private static List<string> h = new List<string>();

	private static object i = new object();

	private static object j = new object();

	private static bool k = true;

	private static bool l = false;

	private a m;

	public b(ILog A_0)
	{
		f = A_0;
		b();
	}

	public List<g> c(bool A_0)
	{
		if (Com.Raritan.Core.a.c() && !A_0 && !Com.Raritan.Core.a.b())
		{
			try
			{
				return a(A_0: false);
			}
			catch (Exception exception)
			{
				f.Error(Com.Raritan.Core.b.d("Could not enumerate LSP forwarded drives"), exception);
			}
			return new List<g>();
		}
		try
		{
			if (a(f))
			{
				return a(A_0: true);
			}
		}
		catch (Exception exception2)
		{
			f.Error(Com.Raritan.Core.b.d("Could not enumerate local drives"), exception2);
		}
		return new List<g>();
	}

	List<g> Com.Raritan.VmCore.c.a(bool A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in c
		return this.c(A_0);
	}

	public static void a(g A_0, bool A_1)
	{
		string item = A_0.e();
		lock (i)
		{
			if (A_1)
			{
				if (!h.Contains(item))
				{
					h.Add(item);
				}
			}
			else if (h.Contains(item))
			{
				h.Remove(item);
			}
		}
	}

	private static bool a(ILog A_0)
	{
		lock (j)
		{
			if (l)
			{
				A_0.Info(Com.Raritan.Core.b.d("Loading native code failed before."));
				return false;
			}
			if (k)
			{
				try
				{
					new Com.Raritan.VmCore.Impl.a().f();
					k = false;
					A_0.Info(Com.Raritan.Core.b.d("Loading native code successful."));
				}
				catch (Exception exception)
				{
					l = true;
					A_0.Error(Com.Raritan.Core.b.d("Loading native code failed"), exception);
					return false;
				}
			}
			return true;
		}
	}

	private void b()
	{
		if (Com.Raritan.VmCore.Impl.a.e())
		{
			m = new c();
		}
		else
		{
			m = new b();
		}
	}

	private IntPtr b(bool A_0)
	{
		return m.a(A_0);
	}

	private void a(IntPtr A_0)
	{
		m.a(A_0);
	}

	private IntPtr c(IntPtr A_0, int A_1)
	{
		return m.a(A_0, A_1);
	}

	private string b(IntPtr A_0, int A_1)
	{
		return m.b(A_0, A_1);
	}

	private int a(IntPtr A_0, int A_1)
	{
		return m.c(A_0, A_1);
	}

	private static List<g> a(List<g> A_0)
	{
		List<g> list = new List<g>();
		lock (i)
		{
			foreach (g item in A_0)
			{
				if (!h.Contains(item.e()))
				{
					list.Add(item);
				}
			}
			return list;
		}
	}

	private List<g> a()
	{
		Com.Raritan.VmCore.Impl.App.a a2 = Com.Raritan.VmCore.Impl.App.a.a(f);
		Com.Raritan.VmCore.Impl.Lsp.c c2 = a2.d();
		List<g> a_ = c2.a();
		return a(a_);
	}

	private List<g> a(bool A_0)
	{
		if (g != IntPtr.Zero)
		{
			a(g);
		}
		g = b(A_0);
		List<g> a_ = a(g, A_0);
		return a(a_);
	}

	private List<g> a(IntPtr A_0, bool A_1)
	{
		List<g> list = new List<g>();
		int num = 0;
		while (true)
		{
			IntPtr intPtr = c(A_0, num);
			if (intPtr == IntPtr.Zero)
			{
				break;
			}
			string a_ = b(A_0, num);
			int a_2 = a(A_0, num);
			Com.Raritan.VmCore.a.c a_3 = a(a_2);
			if (A_1)
			{
				list.Add(new Com.Raritan.VmCore.Impl.Media.a(a_, a_3, intPtr, f));
			}
			else
			{
				list.Add(new Com.Raritan.VmCore.Impl.Media.c(a_, a_3, intPtr, f));
			}
			num++;
		}
		return list;
	}

	private static Com.Raritan.VmCore.a.c a(int A_0)
	{
		return A_0 switch
		{
			0 => Com.Raritan.VmCore.a.c.d, 
			1 => Com.Raritan.VmCore.a.c.f, 
			2 => Com.Raritan.VmCore.a.c.b, 
			3 => Com.Raritan.VmCore.a.c.e, 
			4 => Com.Raritan.VmCore.a.c.h, 
			5 => Com.Raritan.VmCore.a.c.g, 
			-1 => Com.Raritan.VmCore.a.c.a, 
			_ => Com.Raritan.VmCore.a.c.a, 
		};
	}
}
