using System;
using System.ComponentModel;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using SharpDX.Design;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[TypeConverter(typeof(SharpDX.Design.k))]
[DefaultMember("Item")]
public struct q : IEquatable<q>, IFormattable
{
	public static readonly int a = Marshal.SizeOf(typeof(q));

	public static readonly q b = default(q);

	public static readonly q c = new q
	{
		d = 1f,
		i = 1f,
		n = 1f,
		s = 1f
	};

	public float d;

	public float e;

	public float f;

	public float g;

	public float h;

	public float i;

	public float j;

	public float k;

	public float l;

	public float m;

	public float n;

	public float o;

	public float p;

	public float q;

	public float r;

	public float s;

	public q(float A_0)
	{
		this.d = (this.e = (this.f = (this.g = (this.h = (this.i = (this.j = (this.k = (this.l = (this.m = (this.n = (this.o = (this.p = (this.q = (this.r = (this.s = A_0)))))))))))))));
	}

	public q(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5, float A_6, float A_7, float A_8, float A_9, float A_10, float A_11, float A_12, float A_13, float A_14, float A_15)
	{
		this.d = A_0;
		this.e = A_1;
		this.f = A_2;
		this.g = A_3;
		this.h = A_4;
		this.i = A_5;
		this.j = A_6;
		this.k = A_7;
		this.l = A_8;
		this.m = A_9;
		this.n = A_10;
		this.o = A_11;
		this.p = A_12;
		this.q = A_13;
		this.r = A_14;
		this.s = A_15;
	}

	public q(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 16)
		{
			throw new ArgumentOutOfRangeException("values", "There must be sixteen and only sixteen input values for Matrix.");
		}
		this.d = A_0[0];
		this.e = A_0[1];
		this.f = A_0[2];
		this.g = A_0[3];
		this.h = A_0[4];
		this.i = A_0[5];
		this.j = A_0[6];
		this.k = A_0[7];
		this.l = A_0[8];
		this.m = A_0[9];
		this.n = A_0[10];
		this.o = A_0[11];
		this.p = A_0[12];
		this.q = A_0[13];
		this.r = A_0[14];
		this.s = A_0[15];
	}

	[SpecialName]
	public i m()
	{
		return new i(this.d, this.e, this.f, this.g);
	}

	[SpecialName]
	public void g(i A_0)
	{
		this.d = A_0.h;
		this.e = A_0.i;
		this.f = A_0.j;
		this.g = A_0.k;
	}

	[SpecialName]
	public i p()
	{
		return new i(this.h, this.i, this.j, this.k);
	}

	[SpecialName]
	public void c(i A_0)
	{
		this.h = A_0.h;
		this.i = A_0.i;
		this.j = A_0.j;
		this.k = A_0.k;
	}

	[SpecialName]
	public i r()
	{
		return new i(this.l, this.m, this.n, this.o);
	}

	[SpecialName]
	public void e(i A_0)
	{
		this.l = A_0.h;
		this.m = A_0.i;
		this.n = A_0.j;
		this.o = A_0.k;
	}

	[SpecialName]
	public i o()
	{
		return new i(this.p, this.q, this.r, this.s);
	}

	[SpecialName]
	public void b(i A_0)
	{
		this.p = A_0.h;
		this.q = A_0.i;
		this.r = A_0.j;
		this.s = A_0.k;
	}

	[SpecialName]
	public i l()
	{
		return new i(this.d, this.h, this.l, this.p);
	}

	[SpecialName]
	public void h(i A_0)
	{
		this.d = A_0.h;
		this.h = A_0.i;
		this.l = A_0.j;
		this.p = A_0.k;
	}

	[SpecialName]
	public i b()
	{
		return new i(this.e, this.i, this.m, this.q);
	}

	[SpecialName]
	public void f(i A_0)
	{
		this.e = A_0.h;
		this.i = A_0.i;
		this.m = A_0.j;
		this.q = A_0.k;
	}

	[SpecialName]
	public i j()
	{
		return new i(this.f, this.j, this.n, this.r);
	}

	[SpecialName]
	public void d(i A_0)
	{
		this.f = A_0.h;
		this.j = A_0.i;
		this.n = A_0.j;
		this.r = A_0.k;
	}

	[SpecialName]
	public i e()
	{
		return new i(this.g, this.k, this.o, this.s);
	}

	[SpecialName]
	public void a(i A_0)
	{
		this.g = A_0.h;
		this.k = A_0.i;
		this.o = A_0.j;
		this.s = A_0.k;
	}

	[SpecialName]
	public a g()
	{
		return new a(this.p, this.q, this.r);
	}

	[SpecialName]
	public void c(a A_0)
	{
		this.p = A_0.g;
		this.q = A_0.h;
		this.r = A_0.i;
	}

	[SpecialName]
	public a a()
	{
		return new a(this.d, this.i, this.n);
	}

	[SpecialName]
	public void d(a A_0)
	{
		this.d = A_0.g;
		this.i = A_0.h;
		this.n = A_0.i;
	}

	[SpecialName]
	public bool f()
	{
		return k(SharpDX.q.c);
	}

	[SpecialName]
	public float a(int A_0)
	{
		return A_0 switch
		{
			0 => this.d, 
			1 => this.e, 
			2 => this.f, 
			3 => this.g, 
			4 => this.h, 
			5 => this.i, 
			6 => this.j, 
			7 => this.k, 
			8 => this.l, 
			9 => this.m, 
			10 => this.n, 
			11 => this.o, 
			12 => this.p, 
			13 => this.q, 
			14 => this.r, 
			15 => this.s, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Matrix run from 0 to 15, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.d = A_1;
			break;
		case 1:
			this.e = A_1;
			break;
		case 2:
			this.f = A_1;
			break;
		case 3:
			this.g = A_1;
			break;
		case 4:
			this.h = A_1;
			break;
		case 5:
			this.i = A_1;
			break;
		case 6:
			this.j = A_1;
			break;
		case 7:
			this.k = A_1;
			break;
		case 8:
			this.l = A_1;
			break;
		case 9:
			this.m = A_1;
			break;
		case 10:
			this.n = A_1;
			break;
		case 11:
			this.o = A_1;
			break;
		case 12:
			this.p = A_1;
			break;
		case 13:
			this.q = A_1;
			break;
		case 14:
			this.r = A_1;
			break;
		case 15:
			this.s = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Matrix run from 0 to 15, inclusive.");
		}
	}

	[SpecialName]
	public float b(int A_0, int A_1)
	{
		if (A_0 < 0 || A_0 > 3)
		{
			throw new ArgumentOutOfRangeException("row", "Rows and columns for matrices run from 0 to 3, inclusive.");
		}
		if (A_1 < 0 || A_1 > 3)
		{
			throw new ArgumentOutOfRangeException("column", "Rows and columns for matrices run from 0 to 3, inclusive.");
		}
		return a(A_0 * 4 + A_1);
	}

	[SpecialName]
	public void a(int A_0, int A_1, float A_2)
	{
		if (A_0 < 0 || A_0 > 3)
		{
			throw new ArgumentOutOfRangeException("row", "Rows and columns for matrices run from 0 to 3, inclusive.");
		}
		if (A_1 < 0 || A_1 > 3)
		{
			throw new ArgumentOutOfRangeException("column", "Rows and columns for matrices run from 0 to 3, inclusive.");
		}
		a(A_0 * 4 + A_1, A_2);
	}

	public float c()
	{
		float num = this.n * this.s - this.o * this.r;
		float num2 = this.m * this.s - this.o * this.q;
		float num3 = this.m * this.r - this.n * this.q;
		float num4 = this.l * this.s - this.o * this.p;
		float num5 = this.l * this.r - this.n * this.p;
		float num6 = this.l * this.q - this.m * this.p;
		return this.d * (this.i * num - this.j * num2 + this.k * num3) - this.e * (this.h * num - this.j * num4 + this.k * num5) + this.f * (this.h * num2 - this.i * num4 + this.k * num6) - this.g * (this.h * num3 - this.i * num5 + this.j * num6);
	}

	public void h()
	{
		f(ref this, out this);
	}

	public void k()
	{
		g(ref this, out this);
	}

	public void s()
	{
		e(ref this, out this);
	}

	public void i()
	{
		d(ref this, out this);
	}

	public void i(out q A_0, out q A_1)
	{
		q A_2 = this;
		A_2.k();
		d(ref A_2, out A_0);
		A_0.k();
		A_1 = default(q);
		A_1.d = SharpDX.i.g(A_0.l(), l());
		A_1.e = SharpDX.i.g(A_0.l(), b());
		A_1.f = SharpDX.i.g(A_0.l(), j());
		A_1.g = SharpDX.i.g(A_0.l(), e());
		A_1.i = SharpDX.i.g(A_0.b(), b());
		A_1.j = SharpDX.i.g(A_0.b(), j());
		A_1.k = SharpDX.i.g(A_0.b(), e());
		A_1.n = SharpDX.i.g(A_0.j(), j());
		A_1.o = SharpDX.i.g(A_0.j(), e());
		A_1.s = SharpDX.i.g(A_0.e(), e());
	}

	public void j(out q A_0, out q A_1)
	{
		d(ref this, out A_1);
		A_0 = default(q);
		A_0.d = SharpDX.i.g(A_1.m(), m());
		A_0.h = SharpDX.i.g(A_1.m(), p());
		A_0.i = SharpDX.i.g(A_1.p(), p());
		A_0.l = SharpDX.i.g(A_1.m(), r());
		A_0.m = SharpDX.i.g(A_1.p(), r());
		A_0.n = SharpDX.i.g(A_1.r(), r());
		A_0.p = SharpDX.i.g(A_1.m(), o());
		A_0.q = SharpDX.i.g(A_1.p(), o());
		A_0.r = SharpDX.i.g(A_1.r(), o());
		A_0.s = SharpDX.i.g(A_1.o(), o());
	}

	public bool a(out a A_0, out v A_1, out a A_2)
	{
		A_2.g = this.p;
		A_2.h = this.q;
		A_2.i = this.r;
		A_0.g = (float)Math.Sqrt(this.d * this.d + this.e * this.e + this.f * this.f);
		A_0.h = (float)Math.Sqrt(this.h * this.h + this.i * this.i + this.j * this.j);
		A_0.i = (float)Math.Sqrt(this.l * this.l + this.m * this.m + this.n * this.n);
		if (Math.Abs(A_0.g) < 1E-06f || Math.Abs(A_0.h) < 1E-06f || Math.Abs(A_0.i) < 1E-06f)
		{
			A_1 = v.d;
			return false;
		}
		q A_3 = default(q);
		A_3.d = this.d / A_0.g;
		A_3.e = this.e / A_0.g;
		A_3.f = this.f / A_0.g;
		A_3.h = this.h / A_0.h;
		A_3.i = this.i / A_0.h;
		A_3.j = this.j / A_0.h;
		A_3.l = this.l / A_0.i;
		A_3.m = this.m / A_0.i;
		A_3.n = this.n / A_0.i;
		A_3.s = 1f;
		v.a(ref A_3, out A_1);
		return true;
	}

	public void c(int A_0, int A_1)
	{
		if (A_0 < 0)
		{
			throw new ArgumentOutOfRangeException("firstRow", "The parameter firstRow must be greater than or equal to zero.");
		}
		if (A_0 > 3)
		{
			throw new ArgumentOutOfRangeException("firstRow", "The parameter firstRow must be less than or equal to three.");
		}
		if (A_1 < 0)
		{
			throw new ArgumentOutOfRangeException("secondRow", "The parameter secondRow must be greater than or equal to zero.");
		}
		if (A_1 > 3)
		{
			throw new ArgumentOutOfRangeException("secondRow", "The parameter secondRow must be less than or equal to three.");
		}
		if (A_0 != A_1)
		{
			float a_ = b(A_1, 0);
			float a_2 = b(A_1, 1);
			float a_3 = b(A_1, 2);
			float a_4 = b(A_1, 3);
			a(A_1, 0, b(A_0, 0));
			a(A_1, 1, b(A_0, 1));
			a(A_1, 2, b(A_0, 2));
			a(A_1, 3, b(A_0, 3));
			a(A_0, 0, a_);
			a(A_0, 1, a_2);
			a(A_0, 2, a_3);
			a(A_0, 3, a_4);
		}
	}

	public void a(int A_0, int A_1)
	{
		if (A_0 < 0)
		{
			throw new ArgumentOutOfRangeException("firstColumn", "The parameter firstColumn must be greater than or equal to zero.");
		}
		if (A_0 > 3)
		{
			throw new ArgumentOutOfRangeException("firstColumn", "The parameter firstColumn must be less than or equal to three.");
		}
		if (A_1 < 0)
		{
			throw new ArgumentOutOfRangeException("secondColumn", "The parameter secondColumn must be greater than or equal to zero.");
		}
		if (A_1 > 3)
		{
			throw new ArgumentOutOfRangeException("secondColumn", "The parameter secondColumn must be less than or equal to three.");
		}
		if (A_0 != A_1)
		{
			float a_ = b(0, A_1);
			float a_2 = b(1, A_1);
			float a_3 = b(2, A_1);
			float a_4 = b(3, A_1);
			a(0, A_1, b(0, A_0));
			a(1, A_1, b(1, A_0));
			a(2, A_1, b(2, A_0));
			a(3, A_1, b(3, A_0));
			a(0, A_0, a_);
			a(1, A_0, a_2);
			a(2, A_0, a_3);
			a(3, A_0, a_4);
		}
	}

	public float[] n()
	{
		return new float[16]
		{
			this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l, this.m,
			this.n, this.o, this.p, this.q, this.r, this.s
		};
	}

	public static void d(ref q A_0, ref q A_1, out q A_2)
	{
		A_2.d = A_0.d + A_1.d;
		A_2.e = A_0.e + A_1.e;
		A_2.f = A_0.f + A_1.f;
		A_2.g = A_0.g + A_1.g;
		A_2.h = A_0.h + A_1.h;
		A_2.i = A_0.i + A_1.i;
		A_2.j = A_0.j + A_1.j;
		A_2.k = A_0.k + A_1.k;
		A_2.l = A_0.l + A_1.l;
		A_2.m = A_0.m + A_1.m;
		A_2.n = A_0.n + A_1.n;
		A_2.o = A_0.o + A_1.o;
		A_2.p = A_0.p + A_1.p;
		A_2.q = A_0.q + A_1.q;
		A_2.r = A_0.r + A_1.r;
		A_2.s = A_0.s + A_1.s;
	}

	public static q j(q A_0, q A_1)
	{
		d(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void c(ref q A_0, ref q A_1, out q A_2)
	{
		A_2.d = A_0.d - A_1.d;
		A_2.e = A_0.e - A_1.e;
		A_2.f = A_0.f - A_1.f;
		A_2.g = A_0.g - A_1.g;
		A_2.h = A_0.h - A_1.h;
		A_2.i = A_0.i - A_1.i;
		A_2.j = A_0.j - A_1.j;
		A_2.k = A_0.k - A_1.k;
		A_2.l = A_0.l - A_1.l;
		A_2.m = A_0.m - A_1.m;
		A_2.n = A_0.n - A_1.n;
		A_2.o = A_0.o - A_1.o;
		A_2.p = A_0.p - A_1.p;
		A_2.q = A_0.q - A_1.q;
		A_2.r = A_0.r - A_1.r;
		A_2.s = A_0.s - A_1.s;
	}

	public static q i(q A_0, q A_1)
	{
		c(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void b(ref q A_0, float A_1, out q A_2)
	{
		A_2.d = A_0.d * A_1;
		A_2.e = A_0.e * A_1;
		A_2.f = A_0.f * A_1;
		A_2.g = A_0.g * A_1;
		A_2.h = A_0.h * A_1;
		A_2.i = A_0.i * A_1;
		A_2.j = A_0.j * A_1;
		A_2.k = A_0.k * A_1;
		A_2.l = A_0.l * A_1;
		A_2.m = A_0.m * A_1;
		A_2.n = A_0.n * A_1;
		A_2.o = A_0.o * A_1;
		A_2.p = A_0.p * A_1;
		A_2.q = A_0.q * A_1;
		A_2.r = A_0.r * A_1;
		A_2.s = A_0.s * A_1;
	}

	public static q d(q A_0, float A_1)
	{
		b(ref A_0, A_1, out var A_2);
		return A_2;
	}

	public static void b(ref q A_0, ref q A_1, out q A_2)
	{
		A_2 = default(q);
		A_2.d = A_0.d * A_1.d + A_0.e * A_1.h + A_0.f * A_1.l + A_0.g * A_1.p;
		A_2.e = A_0.d * A_1.e + A_0.e * A_1.i + A_0.f * A_1.m + A_0.g * A_1.q;
		A_2.f = A_0.d * A_1.f + A_0.e * A_1.j + A_0.f * A_1.n + A_0.g * A_1.r;
		A_2.g = A_0.d * A_1.g + A_0.e * A_1.k + A_0.f * A_1.o + A_0.g * A_1.s;
		A_2.h = A_0.h * A_1.d + A_0.i * A_1.h + A_0.j * A_1.l + A_0.k * A_1.p;
		A_2.i = A_0.h * A_1.e + A_0.i * A_1.i + A_0.j * A_1.m + A_0.k * A_1.q;
		A_2.j = A_0.h * A_1.f + A_0.i * A_1.j + A_0.j * A_1.n + A_0.k * A_1.r;
		A_2.k = A_0.h * A_1.g + A_0.i * A_1.k + A_0.j * A_1.o + A_0.k * A_1.s;
		A_2.l = A_0.l * A_1.d + A_0.m * A_1.h + A_0.n * A_1.l + A_0.o * A_1.p;
		A_2.m = A_0.l * A_1.e + A_0.m * A_1.i + A_0.n * A_1.m + A_0.o * A_1.q;
		A_2.n = A_0.l * A_1.f + A_0.m * A_1.j + A_0.n * A_1.n + A_0.o * A_1.r;
		A_2.o = A_0.l * A_1.g + A_0.m * A_1.k + A_0.n * A_1.o + A_0.o * A_1.s;
		A_2.p = A_0.p * A_1.d + A_0.q * A_1.h + A_0.r * A_1.l + A_0.s * A_1.p;
		A_2.q = A_0.p * A_1.e + A_0.q * A_1.i + A_0.r * A_1.m + A_0.s * A_1.q;
		A_2.r = A_0.p * A_1.f + A_0.q * A_1.j + A_0.r * A_1.n + A_0.s * A_1.r;
		A_2.s = A_0.p * A_1.g + A_0.q * A_1.k + A_0.r * A_1.o + A_0.s * A_1.s;
	}

	public static q h(q A_0, q A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(ref q A_0, float A_1, out q A_2)
	{
		float num = 1f / A_1;
		A_2.d = A_0.d * num;
		A_2.e = A_0.e * num;
		A_2.f = A_0.f * num;
		A_2.g = A_0.g * num;
		A_2.h = A_0.h * num;
		A_2.i = A_0.i * num;
		A_2.j = A_0.j * num;
		A_2.k = A_0.k * num;
		A_2.l = A_0.l * num;
		A_2.m = A_0.m * num;
		A_2.n = A_0.n * num;
		A_2.o = A_0.o * num;
		A_2.p = A_0.p * num;
		A_2.q = A_0.q * num;
		A_2.r = A_0.r * num;
		A_2.s = A_0.s * num;
	}

	public static q c(q A_0, float A_1)
	{
		a(ref A_0, A_1, out var A_2);
		return A_2;
	}

	public static void a(ref q A_0, ref q A_1, out q A_2)
	{
		A_2.d = A_0.d / A_1.d;
		A_2.e = A_0.e / A_1.e;
		A_2.f = A_0.f / A_1.f;
		A_2.g = A_0.g / A_1.g;
		A_2.h = A_0.h / A_1.h;
		A_2.i = A_0.i / A_1.i;
		A_2.j = A_0.j / A_1.j;
		A_2.k = A_0.k / A_1.k;
		A_2.l = A_0.l / A_1.l;
		A_2.m = A_0.m / A_1.m;
		A_2.n = A_0.n / A_1.n;
		A_2.o = A_0.o / A_1.o;
		A_2.p = A_0.p / A_1.p;
		A_2.q = A_0.q / A_1.q;
		A_2.r = A_0.r / A_1.r;
		A_2.s = A_0.s / A_1.s;
	}

	public static q g(q A_0, q A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(ref q A_0, int A_1, out q A_2)
	{
		if (A_1 < 0)
		{
			throw new ArgumentOutOfRangeException("exponent", "The exponent can not be negative.");
		}
		switch (A_1)
		{
		case 0:
			A_2 = SharpDX.q.c;
			return;
		case 1:
			A_2 = A_0;
			return;
		}
		q q2 = SharpDX.q.c;
		q q3 = A_0;
		while (true)
		{
			if ((A_1 & 1) != 0)
			{
				q2 = d(q2, q3);
			}
			A_1 /= 2;
			if (A_1 <= 0)
			{
				break;
			}
			q3 = d(q3, q3);
		}
		A_2 = q2;
	}

	public static q a(q A_0, int A_1)
	{
		a(ref A_0, A_1, out var A_2);
		return A_2;
	}

	public static void h(ref q A_0, out q A_1)
	{
		A_1.d = 0f - A_0.d;
		A_1.e = 0f - A_0.e;
		A_1.f = 0f - A_0.f;
		A_1.g = 0f - A_0.g;
		A_1.h = 0f - A_0.h;
		A_1.i = 0f - A_0.i;
		A_1.j = 0f - A_0.j;
		A_1.k = 0f - A_0.k;
		A_1.l = 0f - A_0.l;
		A_1.m = 0f - A_0.m;
		A_1.n = 0f - A_0.n;
		A_1.o = 0f - A_0.o;
		A_1.p = 0f - A_0.p;
		A_1.q = 0f - A_0.q;
		A_1.r = 0f - A_0.r;
		A_1.s = 0f - A_0.s;
	}

	public static q j(q A_0)
	{
		h(ref A_0, out var A_1);
		return A_1;
	}

	public static void b(ref q A_0, ref q A_1, float A_2, out q A_3)
	{
		A_3.d = A_0.d + (A_1.d - A_0.d) * A_2;
		A_3.e = A_0.e + (A_1.e - A_0.e) * A_2;
		A_3.f = A_0.f + (A_1.f - A_0.f) * A_2;
		A_3.g = A_0.g + (A_1.g - A_0.g) * A_2;
		A_3.h = A_0.h + (A_1.h - A_0.h) * A_2;
		A_3.i = A_0.i + (A_1.i - A_0.i) * A_2;
		A_3.j = A_0.j + (A_1.j - A_0.j) * A_2;
		A_3.k = A_0.k + (A_1.k - A_0.k) * A_2;
		A_3.l = A_0.l + (A_1.l - A_0.l) * A_2;
		A_3.m = A_0.m + (A_1.m - A_0.m) * A_2;
		A_3.n = A_0.n + (A_1.n - A_0.n) * A_2;
		A_3.o = A_0.o + (A_1.o - A_0.o) * A_2;
		A_3.p = A_0.p + (A_1.p - A_0.p) * A_2;
		A_3.q = A_0.q + (A_1.q - A_0.q) * A_2;
		A_3.r = A_0.r + (A_1.r - A_0.r) * A_2;
		A_3.s = A_0.s + (A_1.s - A_0.s) * A_2;
	}

	public static q b(q A_0, q A_1, float A_2)
	{
		b(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(ref q A_0, ref q A_1, float A_2, out q A_3)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		A_3.d = A_0.d + (A_1.d - A_0.d) * A_2;
		A_3.e = A_0.e + (A_1.e - A_0.e) * A_2;
		A_3.f = A_0.f + (A_1.f - A_0.f) * A_2;
		A_3.g = A_0.g + (A_1.g - A_0.g) * A_2;
		A_3.h = A_0.h + (A_1.h - A_0.h) * A_2;
		A_3.i = A_0.i + (A_1.i - A_0.i) * A_2;
		A_3.j = A_0.j + (A_1.j - A_0.j) * A_2;
		A_3.k = A_0.k + (A_1.k - A_0.k) * A_2;
		A_3.l = A_0.l + (A_1.l - A_0.l) * A_2;
		A_3.m = A_0.m + (A_1.m - A_0.m) * A_2;
		A_3.n = A_0.n + (A_1.n - A_0.n) * A_2;
		A_3.o = A_0.o + (A_1.o - A_0.o) * A_2;
		A_3.p = A_0.p + (A_1.p - A_0.p) * A_2;
		A_3.q = A_0.q + (A_1.q - A_0.q) * A_2;
		A_3.r = A_0.r + (A_1.r - A_0.r) * A_2;
		A_3.s = A_0.s + (A_1.s - A_0.s) * A_2;
	}

	public static q a(q A_0, q A_1, float A_2)
	{
		a(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void g(ref q A_0, out q A_1)
	{
		q q2 = default(q);
		q2.d = A_0.d;
		q2.e = A_0.h;
		q2.f = A_0.l;
		q2.g = A_0.p;
		q2.h = A_0.e;
		q2.i = A_0.i;
		q2.j = A_0.m;
		q2.k = A_0.q;
		q2.l = A_0.f;
		q2.m = A_0.j;
		q2.n = A_0.n;
		q2.o = A_0.r;
		q2.p = A_0.g;
		q2.q = A_0.k;
		q2.r = A_0.o;
		q2.s = A_0.s;
		A_1 = q2;
	}

	public static q i(q A_0)
	{
		g(ref A_0, out var A_1);
		return A_1;
	}

	public static void f(ref q A_0, out q A_1)
	{
		float num = A_0.l * A_0.q - A_0.m * A_0.p;
		float num2 = A_0.l * A_0.r - A_0.n * A_0.p;
		float num3 = A_0.o * A_0.p - A_0.l * A_0.s;
		float num4 = A_0.m * A_0.r - A_0.n * A_0.q;
		float num5 = A_0.o * A_0.q - A_0.m * A_0.s;
		float num6 = A_0.n * A_0.s - A_0.o * A_0.r;
		float num7 = A_0.i * num6 + A_0.j * num5 + A_0.k * num4;
		float num8 = A_0.h * num6 + A_0.j * num3 + A_0.k * num2;
		float num9 = A_0.h * (0f - num5) + A_0.i * num3 + A_0.k * num;
		float num10 = A_0.h * num4 + A_0.i * (0f - num2) + A_0.j * num;
		float num11 = A_0.d * num7 - A_0.e * num8 + A_0.f * num9 - A_0.g * num10;
		if (Math.Abs(num11) <= 1E-06f)
		{
			A_1 = SharpDX.q.b;
			return;
		}
		num11 = 1f / num11;
		float num12 = A_0.d * A_0.i - A_0.e * A_0.h;
		float num13 = A_0.d * A_0.j - A_0.f * A_0.h;
		float num14 = A_0.g * A_0.h - A_0.d * A_0.k;
		float num15 = A_0.e * A_0.j - A_0.f * A_0.i;
		float num16 = A_0.g * A_0.i - A_0.e * A_0.k;
		float num17 = A_0.f * A_0.k - A_0.g * A_0.j;
		float num18 = A_0.e * num6 + A_0.f * num5 + A_0.g * num4;
		float num19 = A_0.d * num6 + A_0.f * num3 + A_0.g * num2;
		float num20 = A_0.d * (0f - num5) + A_0.e * num3 + A_0.g * num;
		float num21 = A_0.d * num4 + A_0.e * (0f - num2) + A_0.f * num;
		float num22 = A_0.q * num17 + A_0.r * num16 + A_0.s * num15;
		float num23 = A_0.p * num17 + A_0.r * num14 + A_0.s * num13;
		float num24 = A_0.p * (0f - num16) + A_0.q * num14 + A_0.s * num12;
		float num25 = A_0.p * num15 + A_0.q * (0f - num13) + A_0.r * num12;
		float num26 = A_0.m * num17 + A_0.n * num16 + A_0.o * num15;
		float num27 = A_0.l * num17 + A_0.n * num14 + A_0.o * num13;
		float num28 = A_0.l * (0f - num16) + A_0.m * num14 + A_0.o * num12;
		float num29 = A_0.l * num15 + A_0.m * (0f - num13) + A_0.n * num12;
		A_1.d = num7 * num11;
		A_1.e = (0f - num18) * num11;
		A_1.f = num22 * num11;
		A_1.g = (0f - num26) * num11;
		A_1.h = (0f - num8) * num11;
		A_1.i = num19 * num11;
		A_1.j = (0f - num23) * num11;
		A_1.k = num27 * num11;
		A_1.l = num9 * num11;
		A_1.m = (0f - num20) * num11;
		A_1.n = num24 * num11;
		A_1.o = (0f - num28) * num11;
		A_1.p = (0f - num10) * num11;
		A_1.q = num21 * num11;
		A_1.r = (0f - num25) * num11;
		A_1.s = num29 * num11;
	}

	public static q h(q A_0)
	{
		A_0.h();
		return A_0;
	}

	public static void e(ref q A_0, out q A_1)
	{
		A_1 = A_0;
		A_1.c(SharpDX.i.c(A_1.p(), SharpDX.i.a(SharpDX.i.g(A_1.m(), A_1.p()) / SharpDX.i.g(A_1.m(), A_1.m()), A_1.m())));
		A_1.e(SharpDX.i.c(A_1.r(), SharpDX.i.a(SharpDX.i.g(A_1.m(), A_1.r()) / SharpDX.i.g(A_1.m(), A_1.m()), A_1.m())));
		A_1.e(SharpDX.i.c(A_1.r(), SharpDX.i.a(SharpDX.i.g(A_1.p(), A_1.r()) / SharpDX.i.g(A_1.p(), A_1.p()), A_1.p())));
		A_1.b(SharpDX.i.c(A_1.o(), SharpDX.i.a(SharpDX.i.g(A_1.m(), A_1.o()) / SharpDX.i.g(A_1.m(), A_1.m()), A_1.m())));
		A_1.b(SharpDX.i.c(A_1.o(), SharpDX.i.a(SharpDX.i.g(A_1.p(), A_1.o()) / SharpDX.i.g(A_1.p(), A_1.p()), A_1.p())));
		A_1.b(SharpDX.i.c(A_1.o(), SharpDX.i.a(SharpDX.i.g(A_1.r(), A_1.o()) / SharpDX.i.g(A_1.r(), A_1.r()), A_1.r())));
	}

	public static q g(q A_0)
	{
		e(ref A_0, out var A_1);
		return A_1;
	}

	public static void d(ref q A_0, out q A_1)
	{
		A_1 = A_0;
		A_1.g(SharpDX.i.e(A_1.m()));
		A_1.c(SharpDX.i.c(A_1.p(), SharpDX.i.a(SharpDX.i.g(A_1.m(), A_1.p()), A_1.m())));
		A_1.c(SharpDX.i.e(A_1.p()));
		A_1.e(SharpDX.i.c(A_1.r(), SharpDX.i.a(SharpDX.i.g(A_1.m(), A_1.r()), A_1.m())));
		A_1.e(SharpDX.i.c(A_1.r(), SharpDX.i.a(SharpDX.i.g(A_1.p(), A_1.r()), A_1.p())));
		A_1.e(SharpDX.i.e(A_1.r()));
		A_1.b(SharpDX.i.c(A_1.o(), SharpDX.i.a(SharpDX.i.g(A_1.m(), A_1.o()), A_1.m())));
		A_1.b(SharpDX.i.c(A_1.o(), SharpDX.i.a(SharpDX.i.g(A_1.p(), A_1.o()), A_1.p())));
		A_1.b(SharpDX.i.c(A_1.o(), SharpDX.i.a(SharpDX.i.g(A_1.r(), A_1.o()), A_1.r())));
		A_1.b(SharpDX.i.e(A_1.o()));
	}

	public static q f(q A_0)
	{
		d(ref A_0, out var A_1);
		return A_1;
	}

	public static void c(ref q A_0, out q A_1)
	{
		A_1 = A_0;
		int num = 0;
		int num2 = 4;
		int num3 = 4;
		for (int num4 = 0; num4 < num2; num4++)
		{
			if (num3 <= num)
			{
				break;
			}
			int num5 = num4;
			while (Math.Abs(A_1.b(num5, num)) < 1E-06f)
			{
				num5++;
				if (num5 == num2)
				{
					num5 = num4;
					num++;
					if (num == num3)
					{
						return;
					}
				}
			}
			if (num5 != num4)
			{
				A_1.c(num5, num4);
			}
			float num6 = 1f / A_1.b(num4, num);
			for (; num5 < num2; num5++)
			{
				if (num5 != num4)
				{
					int a_;
					A_1.a(a_ = num5, 0, A_1.b(a_, 0) - A_1.b(num4, 0) * num6 * A_1.b(num5, num));
					int a_2;
					A_1.a(a_2 = num5, 1, A_1.b(a_2, 1) - A_1.b(num4, 1) * num6 * A_1.b(num5, num));
					int a_3;
					A_1.a(a_3 = num5, 2, A_1.b(a_3, 2) - A_1.b(num4, 2) * num6 * A_1.b(num5, num));
					int a_4;
					A_1.a(a_4 = num5, 3, A_1.b(a_4, 3) - A_1.b(num4, 3) * num6 * A_1.b(num5, num));
				}
			}
			num++;
		}
	}

	public static q e(q A_0)
	{
		c(ref A_0, out var A_1);
		return A_1;
	}

	public static void b(ref q A_0, out q A_1)
	{
		q A_2 = A_0;
		g(ref A_2, out A_1);
		int num = 0;
		int num2 = 4;
		int num3 = 4;
		for (int num4 = 0; num4 < num2; num4++)
		{
			if (num3 <= num)
			{
				return;
			}
			int num5 = num4;
			while (Math.Abs(A_1.b(num5, num)) < 1E-06f)
			{
				num5++;
				if (num5 == num2)
				{
					num5 = num4;
					num++;
					if (num == num3)
					{
						return;
					}
				}
			}
			if (num5 != num4)
			{
				A_1.c(num5, num4);
			}
			float num6 = 1f / A_1.b(num4, num);
			for (; num5 < num2; num5++)
			{
				if (num5 != num4)
				{
					int a_;
					A_1.a(a_ = num5, 0, A_1.b(a_, 0) - A_1.b(num4, 0) * num6 * A_1.b(num5, num));
					int a_2;
					A_1.a(a_2 = num5, 1, A_1.b(a_2, 1) - A_1.b(num4, 1) * num6 * A_1.b(num5, num));
					int a_3;
					A_1.a(a_3 = num5, 2, A_1.b(a_3, 2) - A_1.b(num4, 2) * num6 * A_1.b(num5, num));
					int a_4;
					A_1.a(a_4 = num5, 3, A_1.b(a_4, 3) - A_1.b(num4, 3) * num6 * A_1.b(num5, num));
				}
			}
			num++;
		}
		g(ref A_1, out A_1);
	}

	public static q d(q A_0)
	{
		b(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(ref q A_0, out q A_1)
	{
		A_1 = A_0;
		int num = 0;
		int num2 = 4;
		int num3 = 4;
		for (int num4 = 0; num4 < num2; num4++)
		{
			if (num3 <= num)
			{
				break;
			}
			int num5 = num4;
			while (Math.Abs(A_1.b(num5, num)) < 1E-06f)
			{
				num5++;
				if (num5 == num2)
				{
					num5 = num4;
					num++;
					if (num == num3)
					{
						return;
					}
				}
			}
			if (num5 != num4)
			{
				A_1.c(num5, num4);
			}
			float num6 = 1f / A_1.b(num4, num);
			int a_;
			A_1.a(a_ = num4, 0, A_1.b(a_, 0) * num6);
			int a_2;
			A_1.a(a_2 = num4, 1, A_1.b(a_2, 1) * num6);
			int a_3;
			A_1.a(a_3 = num4, 2, A_1.b(a_3, 2) * num6);
			int a_4;
			A_1.a(a_4 = num4, 3, A_1.b(a_4, 3) * num6);
			for (; num5 < num2; num5++)
			{
				if (num5 != num4)
				{
					int a_5;
					A_1.a(a_5 = num5, 0, A_1.b(a_5, 0) - A_1.b(num4, 0) * A_1.b(num5, num));
					int a_6;
					A_1.a(a_6 = num5, 1, A_1.b(a_6, 1) - A_1.b(num4, 1) * A_1.b(num5, num));
					int a_7;
					A_1.a(a_7 = num5, 2, A_1.b(a_7, 2) - A_1.b(num4, 2) * A_1.b(num5, num));
					int a_8;
					A_1.a(a_8 = num5, 3, A_1.b(a_8, 3) - A_1.b(num4, 3) * A_1.b(num5, num));
				}
			}
			num++;
		}
	}

	public static q c(q A_0)
	{
		a(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(ref q A_0, ref i A_1, out q A_2, out i A_3)
	{
		float[,] array = new float[4, 5]
		{
			{
				A_0.b(0, 0),
				A_0.b(0, 1),
				A_0.b(0, 2),
				A_0.b(0, 3),
				A_1.a(0)
			},
			{
				A_0.b(1, 0),
				A_0.b(1, 1),
				A_0.b(1, 2),
				A_0.b(1, 3),
				A_1.a(1)
			},
			{
				A_0.b(2, 0),
				A_0.b(2, 1),
				A_0.b(2, 2),
				A_0.b(2, 3),
				A_1.a(2)
			},
			{
				A_0.b(3, 0),
				A_0.b(3, 1),
				A_0.b(3, 2),
				A_0.b(3, 3),
				A_1.a(3)
			}
		};
		int num = 0;
		int num2 = 4;
		int num3 = 5;
		for (int num4 = 0; num4 < num2; num4++)
		{
			if (num3 <= num)
			{
				break;
			}
			int num5 = num4;
			while (array[num5, num] == 0f)
			{
				num5++;
				if (num5 == num2)
				{
					num5 = num4;
					num++;
					if (num3 == num)
					{
						break;
					}
				}
			}
			for (int num6 = 0; num6 < num3; num6++)
			{
				float num7 = array[num4, num6];
				array[num4, num6] = array[num5, num6];
				array[num5, num6] = num7;
			}
			float num8 = array[num4, num];
			for (int num9 = 0; num9 < num3; num9++)
			{
				array[num4, num9] /= num8;
			}
			for (int num10 = 0; num10 < num2; num10++)
			{
				if (num10 != num4)
				{
					float num11 = array[num10, num];
					for (int num12 = 0; num12 < num3; num12++)
					{
						array[num10, num12] -= num11 * array[num4, num12];
					}
				}
			}
			num++;
		}
		A_2.d = array[0, 0];
		A_2.e = array[0, 1];
		A_2.f = array[0, 2];
		A_2.g = array[0, 3];
		A_2.h = array[1, 0];
		A_2.i = array[1, 1];
		A_2.j = array[1, 2];
		A_2.k = array[1, 3];
		A_2.l = array[2, 0];
		A_2.m = array[2, 1];
		A_2.n = array[2, 2];
		A_2.o = array[2, 3];
		A_2.p = array[3, 0];
		A_2.q = array[3, 1];
		A_2.r = array[3, 2];
		A_2.s = array[3, 3];
		A_3.h = array[0, 4];
		A_3.i = array[1, 4];
		A_3.j = array[2, 4];
		A_3.k = array[3, 4];
	}

	public static void a(ref a A_0, ref a A_1, ref a A_2, ref a A_3, out q A_4)
	{
		a a_ = SharpDX.a.c(A_0, A_1);
		float num = a_.d();
		a_ = ((!(num < 1E-06f)) ? SharpDX.a.b(a_, (float)(1.0 / Math.Sqrt(num))) : SharpDX.a.c(A_3));
		SharpDX.a.d(ref A_2, ref a_, out var A_5);
		A_5.a();
		SharpDX.a.d(ref a_, ref A_5, out var A_6);
		A_4.d = A_5.g;
		A_4.e = A_5.h;
		A_4.f = A_5.i;
		A_4.g = 0f;
		A_4.h = A_6.g;
		A_4.i = A_6.h;
		A_4.j = A_6.i;
		A_4.k = 0f;
		A_4.l = a_.g;
		A_4.m = a_.h;
		A_4.n = a_.i;
		A_4.o = 0f;
		A_4.p = A_0.g;
		A_4.q = A_0.h;
		A_4.r = A_0.i;
		A_4.s = 1f;
	}

	public static q a(a A_0, a A_1, a A_2, a A_3)
	{
		a(ref A_0, ref A_1, ref A_2, ref A_3, out var A_4);
		return A_4;
	}

	public static void b(ref a A_0, ref a A_1, ref a A_2, out q A_3)
	{
		SharpDX.a.f(ref A_1, ref A_0, out var A_4);
		A_4.a();
		SharpDX.a.d(ref A_2, ref A_4, out var A_5);
		A_5.a();
		SharpDX.a.d(ref A_4, ref A_5, out var A_6);
		A_3 = SharpDX.q.c;
		A_3.d = A_5.g;
		A_3.h = A_5.h;
		A_3.l = A_5.i;
		A_3.e = A_6.g;
		A_3.i = A_6.h;
		A_3.m = A_6.i;
		A_3.f = A_4.g;
		A_3.j = A_4.h;
		A_3.n = A_4.i;
		SharpDX.a.a(ref A_5, ref A_0, out A_3.p);
		SharpDX.a.a(ref A_6, ref A_0, out A_3.q);
		SharpDX.a.a(ref A_4, ref A_0, out A_3.r);
		A_3.p = 0f - A_3.p;
		A_3.q = 0f - A_3.q;
		A_3.r = 0f - A_3.r;
	}

	public static q b(a A_0, a A_1, a A_2)
	{
		b(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void a(ref a A_0, ref a A_1, ref a A_2, out q A_3)
	{
		SharpDX.a.f(ref A_0, ref A_1, out var A_4);
		A_4.a();
		SharpDX.a.d(ref A_2, ref A_4, out var A_5);
		A_5.a();
		SharpDX.a.d(ref A_4, ref A_5, out var A_6);
		A_3 = SharpDX.q.c;
		A_3.d = A_5.g;
		A_3.h = A_5.h;
		A_3.l = A_5.i;
		A_3.e = A_6.g;
		A_3.i = A_6.h;
		A_3.m = A_6.i;
		A_3.f = A_4.g;
		A_3.j = A_4.h;
		A_3.n = A_4.i;
		SharpDX.a.a(ref A_5, ref A_0, out A_3.p);
		SharpDX.a.a(ref A_6, ref A_0, out A_3.q);
		SharpDX.a.a(ref A_4, ref A_0, out A_3.r);
		A_3.p = 0f - A_3.p;
		A_3.q = 0f - A_3.q;
		A_3.r = 0f - A_3.r;
	}

	public static q a(a A_0, a A_1, a A_2)
	{
		a(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void f(float A_0, float A_1, float A_2, float A_3, out q A_4)
	{
		float num = A_0 * 0.5f;
		float num2 = A_1 * 0.5f;
		d(0f - num, num, 0f - num2, num2, A_2, A_3, out A_4);
	}

	public static q f(float A_0, float A_1, float A_2, float A_3)
	{
		f(A_0, A_1, A_2, A_3, out var A_4);
		return A_4;
	}

	public static void e(float A_0, float A_1, float A_2, float A_3, out q A_4)
	{
		float num = A_0 * 0.5f;
		float num2 = A_1 * 0.5f;
		c(0f - num, num, 0f - num2, num2, A_2, A_3, out A_4);
	}

	public static q e(float A_0, float A_1, float A_2, float A_3)
	{
		e(A_0, A_1, A_2, A_3, out var A_4);
		return A_4;
	}

	public static void d(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5, out q A_6)
	{
		float num = 1f / (A_5 - A_4);
		A_6 = SharpDX.q.c;
		A_6.d = 2f / (A_1 - A_0);
		A_6.i = 2f / (A_3 - A_2);
		A_6.n = num;
		A_6.p = (A_0 + A_1) / (A_0 - A_1);
		A_6.q = (A_3 + A_2) / (A_2 - A_3);
		A_6.r = (0f - A_4) * num;
	}

	public static q d(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5)
	{
		d(A_0, A_1, A_2, A_3, A_4, A_5, out var A_6);
		return A_6;
	}

	public static void c(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5, out q A_6)
	{
		d(A_0, A_1, A_2, A_3, A_4, A_5, out A_6);
		A_6.n *= -1f;
	}

	public static q c(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5)
	{
		c(A_0, A_1, A_2, A_3, A_4, A_5, out var A_6);
		return A_6;
	}

	public static void d(float A_0, float A_1, float A_2, float A_3, out q A_4)
	{
		float num = A_0 * 0.5f;
		float num2 = A_1 * 0.5f;
		b(0f - num, num, 0f - num2, num2, A_2, A_3, out A_4);
	}

	public static q d(float A_0, float A_1, float A_2, float A_3)
	{
		d(A_0, A_1, A_2, A_3, out var A_4);
		return A_4;
	}

	public static void c(float A_0, float A_1, float A_2, float A_3, out q A_4)
	{
		float num = A_0 * 0.5f;
		float num2 = A_1 * 0.5f;
		a(0f - num, num, 0f - num2, num2, A_2, A_3, out A_4);
	}

	public static q c(float A_0, float A_1, float A_2, float A_3)
	{
		c(A_0, A_1, A_2, A_3, out var A_4);
		return A_4;
	}

	public static void b(float A_0, float A_1, float A_2, float A_3, out q A_4)
	{
		float num = (float)(1.0 / Math.Tan(A_0 * 0.5f));
		float num2 = num / A_1;
		float num3 = A_2 / num2;
		float num4 = A_2 / num;
		b(0f - num3, num3, 0f - num4, num4, A_2, A_3, out A_4);
	}

	public static q b(float A_0, float A_1, float A_2, float A_3)
	{
		b(A_0, A_1, A_2, A_3, out var A_4);
		return A_4;
	}

	public static void a(float A_0, float A_1, float A_2, float A_3, out q A_4)
	{
		float num = (float)(1.0 / Math.Tan(A_0 * 0.5f));
		float num2 = num / A_1;
		float num3 = A_2 / num2;
		float num4 = A_2 / num;
		a(0f - num3, num3, 0f - num4, num4, A_2, A_3, out A_4);
	}

	public static q a(float A_0, float A_1, float A_2, float A_3)
	{
		a(A_0, A_1, A_2, A_3, out var A_4);
		return A_4;
	}

	public static void b(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5, out q A_6)
	{
		float num = A_5 / (A_5 - A_4);
		A_6 = default(q);
		A_6.d = 2f * A_4 / (A_1 - A_0);
		A_6.i = 2f * A_4 / (A_3 - A_2);
		A_6.l = (A_0 + A_1) / (A_0 - A_1);
		A_6.m = (A_3 + A_2) / (A_2 - A_3);
		A_6.n = num;
		A_6.o = 1f;
		A_6.r = (0f - A_4) * num;
	}

	public static q b(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5)
	{
		b(A_0, A_1, A_2, A_3, A_4, A_5, out var A_6);
		return A_6;
	}

	public static void a(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5, out q A_6)
	{
		b(A_0, A_1, A_2, A_3, A_4, A_5, out A_6);
		A_6.l *= -1f;
		A_6.m *= -1f;
		A_6.n *= -1f;
		A_6.o *= -1f;
	}

	public static q a(float A_0, float A_1, float A_2, float A_3, float A_4, float A_5)
	{
		a(A_0, A_1, A_2, A_3, A_4, A_5, out var A_6);
		return A_6;
	}

	public static void a(ref ap A_0, out q A_1)
	{
		float num = A_0.a.g;
		float num2 = A_0.a.h;
		float num3 = A_0.a.i;
		float num4 = -2f * num;
		float num5 = -2f * num2;
		float num6 = -2f * num3;
		A_1.d = num4 * num + 1f;
		A_1.e = num5 * num;
		A_1.f = num6 * num;
		A_1.g = 0f;
		A_1.h = num4 * num2;
		A_1.i = num5 * num2 + 1f;
		A_1.j = num6 * num2;
		A_1.k = 0f;
		A_1.l = num4 * num3;
		A_1.m = num5 * num3;
		A_1.n = num6 * num3 + 1f;
		A_1.o = 0f;
		A_1.p = num4 * A_0.b;
		A_1.q = num5 * A_0.b;
		A_1.r = num6 * A_0.b;
		A_1.s = 1f;
	}

	public static q a(ap A_0)
	{
		a(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(ref i A_0, ref ap A_1, out q A_2)
	{
		float num = A_1.a.g * A_0.h + A_1.a.h * A_0.i + A_1.a.i * A_0.j + A_1.b * A_0.k;
		float num2 = 0f - A_1.a.g;
		float num3 = 0f - A_1.a.h;
		float num4 = 0f - A_1.a.i;
		float num5 = 0f - A_1.b;
		A_2.d = num2 * A_0.h + num;
		A_2.h = num3 * A_0.h;
		A_2.l = num4 * A_0.h;
		A_2.p = num5 * A_0.h;
		A_2.e = num2 * A_0.i;
		A_2.i = num3 * A_0.i + num;
		A_2.m = num4 * A_0.i;
		A_2.q = num5 * A_0.i;
		A_2.f = num2 * A_0.j;
		A_2.j = num3 * A_0.j;
		A_2.n = num4 * A_0.j + num;
		A_2.r = num5 * A_0.j;
		A_2.g = num2 * A_0.k;
		A_2.k = num3 * A_0.k;
		A_2.o = num4 * A_0.k;
		A_2.s = num5 * A_0.k + num;
	}

	public static q a(i A_0, ap A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void b(ref a A_0, out q A_1)
	{
		c(A_0.g, A_0.h, A_0.i, out A_1);
	}

	public static q b(a A_0)
	{
		b(ref A_0, out var A_1);
		return A_1;
	}

	public static void c(float A_0, float A_1, float A_2, out q A_3)
	{
		A_3 = SharpDX.q.c;
		A_3.d = A_0;
		A_3.i = A_1;
		A_3.n = A_2;
	}

	public static q c(float A_0, float A_1, float A_2)
	{
		c(A_0, A_1, A_2, out var A_3);
		return A_3;
	}

	public static void d(float A_0, out q A_1)
	{
		A_1 = SharpDX.q.c;
		A_1.d = (A_1.i = (A_1.n = A_0));
	}

	public static q d(float A_0)
	{
		d(A_0, out var A_1);
		return A_1;
	}

	public static void c(float A_0, out q A_1)
	{
		float num = (float)Math.Cos(A_0);
		float num2 = (float)Math.Sin(A_0);
		A_1 = SharpDX.q.c;
		A_1.i = num;
		A_1.j = num2;
		A_1.m = 0f - num2;
		A_1.n = num;
	}

	public static q c(float A_0)
	{
		c(A_0, out var A_1);
		return A_1;
	}

	public static void b(float A_0, out q A_1)
	{
		float num = (float)Math.Cos(A_0);
		float num2 = (float)Math.Sin(A_0);
		A_1 = SharpDX.q.c;
		A_1.d = num;
		A_1.f = 0f - num2;
		A_1.l = num2;
		A_1.n = num;
	}

	public static q b(float A_0)
	{
		b(A_0, out var A_1);
		return A_1;
	}

	public static void a(float A_0, out q A_1)
	{
		float num = (float)Math.Cos(A_0);
		float num2 = (float)Math.Sin(A_0);
		A_1 = SharpDX.q.c;
		A_1.d = num;
		A_1.e = num2;
		A_1.h = 0f - num2;
		A_1.i = num;
	}

	public static q a(float A_0)
	{
		a(A_0, out var A_1);
		return A_1;
	}

	public static void a(ref a A_0, float A_1, out q A_2)
	{
		float num = A_0.g;
		float num2 = A_0.h;
		float num3 = A_0.i;
		float num4 = (float)Math.Cos(A_1);
		float num5 = (float)Math.Sin(A_1);
		float num6 = num * num;
		float num7 = num2 * num2;
		float num8 = num3 * num3;
		float num9 = num * num2;
		float num10 = num * num3;
		float num11 = num2 * num3;
		A_2 = SharpDX.q.c;
		A_2.d = num6 + num4 * (1f - num6);
		A_2.e = num9 - num4 * num9 + num5 * num3;
		A_2.f = num10 - num4 * num10 - num5 * num2;
		A_2.h = num9 - num4 * num9 - num5 * num3;
		A_2.i = num7 + num4 * (1f - num7);
		A_2.j = num11 - num4 * num11 + num5 * num;
		A_2.l = num10 - num4 * num10 + num5 * num2;
		A_2.m = num11 - num4 * num11 - num5 * num;
		A_2.n = num8 + num4 * (1f - num8);
	}

	public static q a(a A_0, float A_1)
	{
		a(ref A_0, A_1, out var A_2);
		return A_2;
	}

	public static void a(ref v A_0, out q A_1)
	{
		float num = A_0.e * A_0.e;
		float num2 = A_0.f * A_0.f;
		float num3 = A_0.g * A_0.g;
		float num4 = A_0.e * A_0.f;
		float num5 = A_0.g * A_0.h;
		float num6 = A_0.g * A_0.e;
		float num7 = A_0.f * A_0.h;
		float num8 = A_0.f * A_0.g;
		float num9 = A_0.e * A_0.h;
		A_1 = SharpDX.q.c;
		A_1.d = 1f - 2f * (num2 + num3);
		A_1.e = 2f * (num4 + num5);
		A_1.f = 2f * (num6 - num7);
		A_1.h = 2f * (num4 - num5);
		A_1.i = 1f - 2f * (num3 + num);
		A_1.j = 2f * (num8 + num9);
		A_1.l = 2f * (num6 + num7);
		A_1.m = 2f * (num8 - num9);
		A_1.n = 1f - 2f * (num2 + num);
	}

	public static q a(v A_0)
	{
		a(ref A_0, out var A_1);
		return A_1;
	}

	public static void b(float A_0, float A_1, float A_2, out q A_3)
	{
		v A_4 = default(v);
		v.a(A_0, A_1, A_2, out A_4);
		a(ref A_4, out A_3);
	}

	public static q b(float A_0, float A_1, float A_2)
	{
		b(A_0, A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(ref a A_0, out q A_1)
	{
		a(A_0.g, A_0.h, A_0.i, out A_1);
	}

	public static q a(a A_0)
	{
		a(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(float A_0, float A_1, float A_2, out q A_3)
	{
		A_3 = SharpDX.q.c;
		A_3.p = A_0;
		A_3.q = A_1;
		A_3.r = A_2;
	}

	public static q a(float A_0, float A_1, float A_2)
	{
		a(A_0, A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(float A_0, ref v A_1, ref a A_2, out q A_3)
	{
		A_3 = d(d(d(A_0), a(A_1)), a(A_2));
	}

	public static q a(float A_0, v A_1, a A_2)
	{
		a(A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void a(float A_0, ref a A_1, ref v A_2, ref a A_3, out q A_4)
	{
		A_4 = d(d(d(d(d(A_0), a(SharpDX.a.c(A_1))), a(A_2)), a(A_1)), a(A_3));
	}

	public static q a(float A_0, a A_1, v A_2, a A_3)
	{
		a(A_0, ref A_1, ref A_2, ref A_3, out var A_4);
		return A_4;
	}

	public static void a(float A_0, float A_1, ref au A_2, out q A_3)
	{
		A_3 = d(d(c(A_0, A_0, 1f), a(A_1)), a(au.b(A_2)));
	}

	public static q a(float A_0, float A_1, au A_2)
	{
		a(A_0, A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void a(float A_0, ref au A_1, float A_2, ref au A_3, out q A_4)
	{
		A_4 = d(d(d(d(c(A_0, A_0, 1f), a(au.b(au.c(A_1)))), a(A_2)), a(au.b(A_1))), a(au.b(A_3)));
	}

	public static q a(float A_0, au A_1, float A_2, au A_3)
	{
		a(A_0, ref A_1, A_2, ref A_3, out var A_4);
		return A_4;
	}

	public static void a(ref a A_0, ref v A_1, ref a A_2, ref a A_3, ref v A_4, ref a A_5, out q A_6)
	{
		q q2 = a(A_1);
		A_6 = d(d(d(d(d(d(d(d(a(SharpDX.a.c(A_0)), i(q2)), b(A_2)), q2), a(A_0)), a(SharpDX.a.c(A_3))), a(A_4)), a(A_3)), a(A_5));
	}

	public static q a(a A_0, v A_1, a A_2, a A_3, v A_4, a A_5)
	{
		a(ref A_0, ref A_1, ref A_2, ref A_3, ref A_4, ref A_5, out var A_6);
		return A_6;
	}

	public static void a(ref au A_0, float A_1, ref au A_2, ref au A_3, float A_4, ref au A_5, out q A_6)
	{
		A_6 = d(d(d(d(d(d(d(d(a(au.b(au.c(A_0))), a(0f - A_1)), b(au.b(A_2))), a(A_1)), a(au.b(A_0))), a(au.b(au.c(A_3)))), a(A_4)), a(au.b(A_3))), a(au.b(A_5)));
		A_6.n = 1f;
		A_6.s = 1f;
	}

	public static q a(au A_0, float A_1, au A_2, au A_3, float A_4, au A_5)
	{
		a(ref A_0, A_1, ref A_2, ref A_3, A_4, ref A_5, out var A_6);
		return A_6;
	}

	[SpecialName]
	public static q f(q A_0, q A_1)
	{
		d(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static q b(q A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static q e(q A_0, q A_1)
	{
		c(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static q a(q A_0)
	{
		h(ref A_0, out var A_1);
		return A_1;
	}

	[SpecialName]
	public static q a(float A_0, q A_1)
	{
		b(ref A_1, A_0, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static q b(q A_0, float A_1)
	{
		b(ref A_0, A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static q d(q A_0, q A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static q a(q A_0, float A_1)
	{
		a(ref A_0, A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static q c(q A_0, q A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static bool b(q A_0, q A_1)
	{
		return A_0.k(A_1);
	}

	[SpecialName]
	public static bool a(q A_0, q A_1)
	{
		return !A_0.k(A_1);
	}

	public string d()
	{
		return string.Format(CultureInfo.CurrentCulture, "[M11:{0} M12:{1} M13:{2} M14:{3}] [M21:{4} M22:{5} M23:{6} M24:{7}] [M31:{8} M32:{9} M33:{10} M34:{11}] [M41:{12} M42:{13} M43:{14} M44:{15}]", this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l, this.m, this.n, this.o, this.p, this.q, this.r, this.s);
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(A_0, CultureInfo.CurrentCulture, "[M11:{0} M12:{1} M13:{2} M14:{3}] [M21:{4} M22:{5} M23:{6} M24:{7}] [M31:{8} M32:{9} M33:{10} M34:{11}] [M41:{12} M42:{13} M43:{14} M44:{15}]", this.d.ToString(A_0, CultureInfo.CurrentCulture), this.e.ToString(A_0, CultureInfo.CurrentCulture), this.f.ToString(A_0, CultureInfo.CurrentCulture), this.g.ToString(A_0, CultureInfo.CurrentCulture), this.h.ToString(A_0, CultureInfo.CurrentCulture), this.i.ToString(A_0, CultureInfo.CurrentCulture), this.j.ToString(A_0, CultureInfo.CurrentCulture), this.k.ToString(A_0, CultureInfo.CurrentCulture), this.l.ToString(A_0, CultureInfo.CurrentCulture), this.m.ToString(A_0, CultureInfo.CurrentCulture), this.n.ToString(A_0, CultureInfo.CurrentCulture), this.o.ToString(A_0, CultureInfo.CurrentCulture), this.p.ToString(A_0, CultureInfo.CurrentCulture), this.q.ToString(A_0, CultureInfo.CurrentCulture), this.r.ToString(A_0, CultureInfo.CurrentCulture), this.s.ToString(A_0, CultureInfo.CurrentCulture));
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "[M11:{0} M12:{1} M13:{2} M14:{3}] [M21:{4} M22:{5} M23:{6} M24:{7}] [M31:{8} M32:{9} M33:{10} M34:{11}] [M41:{12} M42:{13} M43:{14} M44:{15}]", this.d.ToString(A_0), this.e.ToString(A_0), this.f.ToString(A_0), this.g.ToString(A_0), this.h.ToString(A_0), this.i.ToString(A_0), this.j.ToString(A_0), this.k.ToString(A_0), this.l.ToString(A_0), this.m.ToString(A_0), this.n.ToString(A_0), this.o.ToString(A_0), this.p.ToString(A_0), this.q.ToString(A_0), this.r.ToString(A_0), this.s.ToString(A_0));
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			return a(A_1);
		}
		return string.Format(A_0, A_1, "[M11:{0} M12:{1} M13:{2} M14:{3}] [M21:{4} M22:{5} M23:{6} M24:{7}] [M31:{8} M32:{9} M33:{10} M34:{11}] [M41:{12} M42:{13} M43:{14} M44:{15}]", this.d.ToString(A_0, A_1), this.e.ToString(A_0, A_1), this.f.ToString(A_0, A_1), this.g.ToString(A_0, A_1), this.h.ToString(A_0, A_1), this.i.ToString(A_0, A_1), this.j.ToString(A_0, A_1), this.k.ToString(A_0, A_1), this.l.ToString(A_0, A_1), this.m.ToString(A_0, A_1), this.n.ToString(A_0, A_1), this.o.ToString(A_0, A_1), this.p.ToString(A_0, A_1), this.q.ToString(A_0, A_1), this.r.ToString(A_0, A_1), this.s.ToString(A_0, A_1));
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int q()
	{
		return this.d.GetHashCode() + this.e.GetHashCode() + this.f.GetHashCode() + this.g.GetHashCode() + this.h.GetHashCode() + this.i.GetHashCode() + this.j.GetHashCode() + this.k.GetHashCode() + this.l.GetHashCode() + this.m.GetHashCode() + this.n.GetHashCode() + this.o.GetHashCode() + this.p.GetHashCode() + this.q.GetHashCode() + this.r.GetHashCode() + this.s.GetHashCode();
	}

	public bool k(q A_0)
	{
		if (Math.Abs(A_0.d - this.d) < 1E-06f && Math.Abs(A_0.e - this.e) < 1E-06f && Math.Abs(A_0.f - this.f) < 1E-06f && Math.Abs(A_0.g - this.g) < 1E-06f && Math.Abs(A_0.h - this.h) < 1E-06f && Math.Abs(A_0.i - this.i) < 1E-06f && Math.Abs(A_0.j - this.j) < 1E-06f && Math.Abs(A_0.k - this.k) < 1E-06f && Math.Abs(A_0.l - this.l) < 1E-06f && Math.Abs(A_0.m - this.m) < 1E-06f && Math.Abs(A_0.n - this.n) < 1E-06f && Math.Abs(A_0.o - this.o) < 1E-06f && Math.Abs(A_0.p - this.p) < 1E-06f && Math.Abs(A_0.q - this.q) < 1E-06f && Math.Abs(A_0.r - this.r) < 1E-06f)
		{
			return Math.Abs(A_0.s - this.s) < 1E-06f;
		}
		return false;
	}

	bool IEquatable<q>.Equals(q A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in k
		return this.k(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return k((q)A_0);
	}
}
