<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
    <ConnectionScriptArray>
      <ConnectionScripts>
        <xsl:for-each select="preferences/root[@type='user']/node[@name='ConnectionScripts']/node">
          <ConnectionScript>
		        <Name><xsl:value-of select="map/entry[@key='name']/@value"/></Name>
		        <Type><xsl:value-of select="map/entry[@key='type']/@value"/></Type>
            <KeyboardType><xsl:value-of select="map/entry[@key='keyboardType']/@value"/></KeyboardType>
            <EditSequence><xsl:value-of select="map/entry[@key='EditSequence']/@value"/></EditSequence>
            <VirtKeySequence><xsl:value-of select="map/entry[@key='VirtKeySequence']/@value"/></VirtKeySequence>
          </ConnectionScript>
        </xsl:for-each>
      </ConnectionScripts>
  </ConnectionScriptArray>
	</xsl:template>
</xsl:stylesheet>