using System;
using System.Collections.Generic;
using System.Runtime.CompilerServices;
using Com.Raritan.Core;
using log4net;

namespace Com.Raritan.RcCore.Impl.Rfb.V01_28;

internal class x : Com.Raritan.RcCore.Impl.Rfb.e
{
	private new class d
	{
		private Dictionary<string, Com.Raritan.RcCore.o.ColorDepth> m_a;

		private Dictionary<string, Com.Raritan.RcCore.o.Compression> m_b;

		private Dictionary<string, Com.Raritan.RcCore.o.c> m_c;

		public d()
		{
			this.m_a = new Dictionary<string, Com.Raritan.RcCore.o.ColorDepth>();
			this.m_a.Add("color_32bpp", Com.Raritan.RcCore.o.ColorDepth.COLOR_32_BIT);
			this.m_a.Add("color_24bpp", Com.Raritan.RcCore.o.ColorDepth.COLOR_24_BIT);
			this.m_a.Add("color_16bpp", Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT);
			this.m_a.Add("color_8bpp", Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT);
			this.m_a.Add("color_4bpp", Com.Raritan.RcCore.o.ColorDepth.COLOR_4_BIT);
			this.m_a.Add("grey_4bpp", Com.Raritan.RcCore.o.ColorDepth.GREY_4_BIT);
			this.m_a.Add("grey_3bpp", Com.Raritan.RcCore.o.ColorDepth.GREY_3_BIT);
			this.m_a.Add("grey_2bpp", Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT);
			this.m_a.Add("grey_1bpp", Com.Raritan.RcCore.o.ColorDepth.BW_1_BIT);
			this.m_b = new Dictionary<string, Com.Raritan.RcCore.o.Compression>();
			this.m_b.Add("uncompressed", Com.Raritan.RcCore.o.Compression.UNCOMPRESSED);
			this.m_b.Add("comp1", Com.Raritan.RcCore.o.Compression.LEVEL_1);
			this.m_b.Add("comp2", Com.Raritan.RcCore.o.Compression.LEVEL_2);
			this.m_b.Add("comp3", Com.Raritan.RcCore.o.Compression.LEVEL_3);
			this.m_b.Add("comp4", Com.Raritan.RcCore.o.Compression.LEVEL_4);
			this.m_b.Add("comp5", Com.Raritan.RcCore.o.Compression.LEVEL_5);
			this.m_b.Add("comp6", Com.Raritan.RcCore.o.Compression.LEVEL_6);
			this.m_b.Add("comp7", Com.Raritan.RcCore.o.Compression.LEVEL_7);
			this.m_b.Add("comp8", Com.Raritan.RcCore.o.Compression.LEVEL_8);
			this.m_b.Add("comp9", Com.Raritan.RcCore.o.Compression.LEVEL_9);
			this.m_c = new Dictionary<string, Com.Raritan.RcCore.o.c>();
			this.m_c.Add("videohi", Com.Raritan.RcCore.o.c.c);
			this.m_c.Add("video", Com.Raritan.RcCore.o.c.d);
			this.m_c.Add("lanhi", Com.Raritan.RcCore.o.c.c);
			this.m_c.Add("lan", Com.Raritan.RcCore.o.c.d);
			this.m_c.Add("dsl", Com.Raritan.RcCore.o.c.e);
			this.m_c.Add("umts", Com.Raritan.RcCore.o.c.f);
			this.m_c.Add("isdn", Com.Raritan.RcCore.o.c.g);
			this.m_c.Add("modem", Com.Raritan.RcCore.o.c.h);
			this.m_c.Add("modem_4bit", Com.Raritan.RcCore.o.c.k);
			this.m_c.Add("gprs", Com.Raritan.RcCore.o.c.i);
			this.m_c.Add("gsm", Com.Raritan.RcCore.o.c.j);
		}

		public Com.Raritan.RcCore.o.ColorDepth a(string A_0)
		{
			try
			{
				return this.m_a[A_0];
			}
			catch (KeyNotFoundException)
			{
				return Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT;
			}
		}

		public Com.Raritan.RcCore.o.Compression b(string A_0)
		{
			try
			{
				return this.m_b[A_0];
			}
			catch (KeyNotFoundException)
			{
				return Com.Raritan.RcCore.o.Compression.UNCOMPRESSED;
			}
		}

		public Com.Raritan.RcCore.o.c c(string A_0)
		{
			try
			{
				return this.m_c[A_0];
			}
			catch (KeyNotFoundException)
			{
				return Com.Raritan.RcCore.o.c.c;
			}
		}
	}

	private new class c
	{
		[CompilerGenerated]
		private Com.Raritan.RcCore.o.c m_a;

		[CompilerGenerated]
		private Com.Raritan.RcCore.o.Compression m_b;

		[CompilerGenerated]
		private Com.Raritan.RcCore.o.ColorDepth m_c;

		[CompilerGenerated]
		private bool m_d;

		[SpecialName]
		[CompilerGenerated]
		public Com.Raritan.RcCore.o.c a()
		{
			return this.m_a;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(Com.Raritan.RcCore.o.c A_0)
		{
			this.m_a = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public Com.Raritan.RcCore.o.Compression d()
		{
			return this.m_b;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(Com.Raritan.RcCore.o.Compression A_0)
		{
			this.m_b = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public Com.Raritan.RcCore.o.ColorDepth c()
		{
			return this.m_c;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(Com.Raritan.RcCore.o.ColorDepth A_0)
		{
			this.m_c = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public bool b()
		{
			return this.m_d;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(bool A_0)
		{
			this.m_d = A_0;
		}

		public c(Com.Raritan.RcCore.o.c A_0, Com.Raritan.RcCore.o.Compression A_1, Com.Raritan.RcCore.o.ColorDepth A_2, bool A_3)
		{
			a(A_0);
			a(A_1);
			a(A_2);
			a(A_3);
		}
	}

	private new class b
	{
		[CompilerGenerated]
		private Com.Raritan.RcCore.o.Compression m_a;

		[CompilerGenerated]
		private uint m_b;

		[CompilerGenerated]
		private uint m_c;

		[CompilerGenerated]
		private List<Com.Raritan.RcCore.o.ColorDepth> m_d;

		[SpecialName]
		[CompilerGenerated]
		public Com.Raritan.RcCore.o.Compression d()
		{
			return this.m_a;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(Com.Raritan.RcCore.o.Compression A_0)
		{
			this.m_a = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public uint c()
		{
			return this.m_b;
		}

		[SpecialName]
		[CompilerGenerated]
		private void b(uint A_0)
		{
			this.m_b = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public uint a()
		{
			return this.m_c;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(uint A_0)
		{
			this.m_c = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public List<Com.Raritan.RcCore.o.ColorDepth> b()
		{
			return this.m_d;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(List<Com.Raritan.RcCore.o.ColorDepth> A_0)
		{
			this.m_d = A_0;
		}

		public b(Com.Raritan.RcCore.o.Compression A_0, List<Com.Raritan.RcCore.o.ColorDepth> A_1, uint A_2, uint A_3)
		{
			a(A_0);
			a(A_1);
			b(A_2);
			a(A_3);
		}
	}

	private new class a
	{
		[CompilerGenerated]
		private Com.Raritan.RcCore.o.ColorDepth m_a;

		[CompilerGenerated]
		private uint m_b;

		[CompilerGenerated]
		private uint m_c;

		[CompilerGenerated]
		private uint m_d;

		[CompilerGenerated]
		private Com.Raritan.RcCore.Impl.Rfb.a m_e;

		[CompilerGenerated]
		private List<Com.Raritan.RcCore.o.Compression> m_f;

		[SpecialName]
		[CompilerGenerated]
		public Com.Raritan.RcCore.o.ColorDepth f()
		{
			return this.m_a;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(Com.Raritan.RcCore.o.ColorDepth A_0)
		{
			this.m_a = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public uint c()
		{
			return this.m_b;
		}

		[SpecialName]
		[CompilerGenerated]
		private void c(uint A_0)
		{
			this.m_b = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public uint b()
		{
			return this.m_c;
		}

		[SpecialName]
		[CompilerGenerated]
		private void b(uint A_0)
		{
			this.m_c = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public uint e()
		{
			return this.m_d;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(uint A_0)
		{
			this.m_d = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public Com.Raritan.RcCore.Impl.Rfb.a a()
		{
			return this.m_e;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(Com.Raritan.RcCore.Impl.Rfb.a A_0)
		{
			this.m_e = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public List<Com.Raritan.RcCore.o.Compression> d()
		{
			return this.m_f;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(List<Com.Raritan.RcCore.o.Compression> A_0)
		{
			this.m_f = A_0;
		}

		public a(Com.Raritan.RcCore.o.ColorDepth A_0, List<Com.Raritan.RcCore.o.Compression> A_1, uint A_2, uint A_3, uint A_4, Com.Raritan.RcCore.Impl.Rfb.a A_5)
		{
			a(A_0);
			a(A_1);
			c(A_2);
			b(A_3);
			a(A_4);
			a(A_5);
		}
	}

	private new const int m_a = 0;

	private new const int m_b = 1;

	private new const int m_c = 2;

	private new const int m_d = 3;

	private new static object m_e = new object();

	private new static d m_f = null;

	private int m_g;

	private Com.Raritan.RcCore.o.ColorDepth m_h = Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT;

	private Com.Raritan.RcCore.o.Compression m_i = Com.Raritan.RcCore.o.Compression.UNCOMPRESSED;

	private bool j;

	private List<c> k;

	private List<c> l;

	private List<b> m;

	private List<b> n;

	private List<a> o;

	private List<a> p;

	private static void i()
	{
		lock (x.m_e)
		{
			if (x.m_f == null)
			{
				x.m_f = new d();
			}
		}
	}

	private static Com.Raritan.RcCore.o.ColorDepth g(string A_0)
	{
		i();
		return x.m_f.a(A_0);
	}

	private static Com.Raritan.RcCore.o.Compression f(string A_0)
	{
		i();
		return x.m_f.b(A_0);
	}

	private static Com.Raritan.RcCore.o.c e(string A_0)
	{
		i();
		return x.m_f.c(A_0);
	}

	public x(ILog A_0, Com.Raritan.RcCore.Impl.g A_1)
		: base(A_0, A_1)
	{
		h();
		g();
	}

	private void h()
	{
		k = new List<c>();
		k.Add(new c(Com.Raritan.RcCore.o.c.c, Com.Raritan.RcCore.o.Compression.UNCOMPRESSED, Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT, A_3: false));
		k.Add(new c(Com.Raritan.RcCore.o.c.d, Com.Raritan.RcCore.o.Compression.UNCOMPRESSED, Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, A_3: false));
		k.Add(new c(Com.Raritan.RcCore.o.c.e, Com.Raritan.RcCore.o.Compression.LEVEL_2, Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, A_3: false));
		k.Add(new c(Com.Raritan.RcCore.o.c.f, Com.Raritan.RcCore.o.Compression.LEVEL_4, Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, A_3: true));
		k.Add(new c(Com.Raritan.RcCore.o.c.g, Com.Raritan.RcCore.o.Compression.LEVEL_6, Com.Raritan.RcCore.o.ColorDepth.COLOR_4_BIT, A_3: true));
		k.Add(new c(Com.Raritan.RcCore.o.c.h, Com.Raritan.RcCore.o.Compression.LEVEL_7, Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT, A_3: true));
		k.Add(new c(Com.Raritan.RcCore.o.c.k, Com.Raritan.RcCore.o.Compression.LEVEL_8, Com.Raritan.RcCore.o.ColorDepth.GREY_4_BIT, A_3: true));
		k.Add(new c(Com.Raritan.RcCore.o.c.i, Com.Raritan.RcCore.o.Compression.LEVEL_8, Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT, A_3: true));
		k.Add(new c(Com.Raritan.RcCore.o.c.j, Com.Raritan.RcCore.o.Compression.LEVEL_9, Com.Raritan.RcCore.o.ColorDepth.BW_1_BIT, A_3: true));
		List<Com.Raritan.RcCore.o.ColorDepth> list = new List<Com.Raritan.RcCore.o.ColorDepth>();
		list.Add(Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.COLOR_4_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.GREY_4_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.BW_1_BIT);
		m = new List<b>();
		m.Add(new b(Com.Raritan.RcCore.o.Compression.UNCOMPRESSED, list, 128u, 0u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_1, list, 128u, 1u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_2, list, 128u, 2u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_3, list, 128u, 3u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_4, list, 128u, 4u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_5, list, 128u, 5u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_6, list, 128u, 6u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_7, list, 128u, 7u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_8, list, 128u, 8u));
		m.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_9, list, 128u, 9u));
		List<Com.Raritan.RcCore.o.Compression> list2 = new List<Com.Raritan.RcCore.o.Compression>();
		list2.Add(Com.Raritan.RcCore.o.Compression.UNCOMPRESSED);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_1);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_2);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_3);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_4);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_5);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_6);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_7);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_8);
		list2.Add(Com.Raritan.RcCore.o.Compression.LEVEL_9);
		o = new List<a>();
		o.Add(new a(Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT, list2, 0u, 0u, 1u, Com.Raritan.RcCore.Impl.Rfb.a.a));
		o.Add(new a(Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, list2, 8u, 2u, 3u, Com.Raritan.RcCore.Impl.Rfb.a.a));
		o.Add(new a(Com.Raritan.RcCore.o.ColorDepth.COLOR_4_BIT, list2, 4u, 5u, 5u, Com.Raritan.RcCore.Impl.Rfb.a.a));
		o.Add(new a(Com.Raritan.RcCore.o.ColorDepth.GREY_4_BIT, list2, 3u, 6u, 7u, Com.Raritan.RcCore.Impl.Rfb.a.a));
		o.Add(new a(Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT, list2, 2u, 10u, 11u, Com.Raritan.RcCore.Impl.Rfb.a.a));
		o.Add(new a(Com.Raritan.RcCore.o.ColorDepth.BW_1_BIT, list2, 1u, 12u, 13u, Com.Raritan.RcCore.Impl.Rfb.a.a));
	}

	private void g()
	{
		l = new List<c>();
		l.Add(new c(Com.Raritan.RcCore.o.c.a, Com.Raritan.RcCore.o.Compression.VIDEO_OPTIMIZED, Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT, A_3: false));
		l.Add(new c(Com.Raritan.RcCore.o.c.b, Com.Raritan.RcCore.o.Compression.VIDEO_OPTIMIZED, Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, A_3: false));
		l.Add(new c(Com.Raritan.RcCore.o.c.c, Com.Raritan.RcCore.o.Compression.UNCOMPRESSED, Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT, A_3: false));
		l.Add(new c(Com.Raritan.RcCore.o.c.d, Com.Raritan.RcCore.o.Compression.UNCOMPRESSED, Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, A_3: false));
		l.Add(new c(Com.Raritan.RcCore.o.c.e, Com.Raritan.RcCore.o.Compression.LEVEL_2, Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, A_3: false));
		l.Add(new c(Com.Raritan.RcCore.o.c.f, Com.Raritan.RcCore.o.Compression.LEVEL_4, Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, A_3: true));
		l.Add(new c(Com.Raritan.RcCore.o.c.g, Com.Raritan.RcCore.o.Compression.LEVEL_6, Com.Raritan.RcCore.o.ColorDepth.COLOR_4_BIT, A_3: true));
		l.Add(new c(Com.Raritan.RcCore.o.c.h, Com.Raritan.RcCore.o.Compression.LEVEL_7, Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT, A_3: true));
		l.Add(new c(Com.Raritan.RcCore.o.c.i, Com.Raritan.RcCore.o.Compression.LEVEL_8, Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT, A_3: true));
		l.Add(new c(Com.Raritan.RcCore.o.c.j, Com.Raritan.RcCore.o.Compression.LEVEL_9, Com.Raritan.RcCore.o.ColorDepth.BW_1_BIT, A_3: true));
		List<Com.Raritan.RcCore.o.ColorDepth> list = new List<Com.Raritan.RcCore.o.ColorDepth>();
		list.Add(Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.COLOR_4_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.GREY_4_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT);
		list.Add(Com.Raritan.RcCore.o.ColorDepth.BW_1_BIT);
		List<Com.Raritan.RcCore.o.ColorDepth> list2 = new List<Com.Raritan.RcCore.o.ColorDepth>();
		list2.Add(Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT);
		list2.Add(Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT);
		n = new List<b>();
		n.Add(new b(Com.Raritan.RcCore.o.Compression.VIDEO_OPTIMIZED, list2, 10u, 0u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.UNCOMPRESSED, list2, 5u, 0u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_1, list, 7u, 1u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_2, list, 7u, 2u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_3, list, 7u, 3u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_4, list, 7u, 4u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_5, list, 7u, 5u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_6, list, 7u, 6u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_7, list, 7u, 7u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_8, list, 7u, 8u));
		n.Add(new b(Com.Raritan.RcCore.o.Compression.LEVEL_9, list, 7u, 9u));
		List<Com.Raritan.RcCore.o.Compression> list3 = new List<Com.Raritan.RcCore.o.Compression>();
		list3.Add(Com.Raritan.RcCore.o.Compression.VIDEO_OPTIMIZED);
		list3.Add(Com.Raritan.RcCore.o.Compression.UNCOMPRESSED);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_1);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_2);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_3);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_4);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_5);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_6);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_7);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_8);
		list3.Add(Com.Raritan.RcCore.o.Compression.LEVEL_9);
		List<Com.Raritan.RcCore.o.Compression> list4 = new List<Com.Raritan.RcCore.o.Compression>();
		list4.Add(Com.Raritan.RcCore.o.Compression.VIDEO_OPTIMIZED);
		list4.Add(Com.Raritan.RcCore.o.Compression.UNCOMPRESSED);
		List<Com.Raritan.RcCore.o.Compression> list5 = new List<Com.Raritan.RcCore.o.Compression>();
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_1);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_2);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_3);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_4);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_5);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_6);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_7);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_8);
		list5.Add(Com.Raritan.RcCore.o.Compression.LEVEL_9);
		p = new List<a>();
		p.Add(new a(Com.Raritan.RcCore.o.ColorDepth.COLOR_16_BIT, list4, 0u, 0u, 0u, Com.Raritan.RcCore.Impl.Rfb.a.a));
		p.Add(new a(Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT, list3, 8u, 0u, 0u, Com.Raritan.RcCore.Impl.Rfb.a.b));
		p.Add(new a(Com.Raritan.RcCore.o.ColorDepth.COLOR_4_BIT, list5, 4u, 0u, 0u, Com.Raritan.RcCore.Impl.Rfb.a.b));
		p.Add(new a(Com.Raritan.RcCore.o.ColorDepth.GREY_4_BIT, list5, 3u, 0u, 0u, Com.Raritan.RcCore.Impl.Rfb.a.b));
		p.Add(new a(Com.Raritan.RcCore.o.ColorDepth.GREY_2_BIT, list5, 2u, 0u, 0u, Com.Raritan.RcCore.Impl.Rfb.a.b));
		p.Add(new a(Com.Raritan.RcCore.o.ColorDepth.BW_1_BIT, list5, 1u, 0u, 0u, Com.Raritan.RcCore.Impl.Rfb.a.b));
	}

	private c e(Com.Raritan.RcCore.o.c A_0)
	{
		List<c> list = (base.c ? k : l);
		foreach (c item in list)
		{
			if (item.a() == A_0)
			{
				return item;
			}
		}
		throw new ArgumentException(Com.Raritan.Core.b.d("Predefined encoding not found"));
	}

	private b d(Com.Raritan.RcCore.o.Compression A_0)
	{
		List<b> list = (base.c ? m : n);
		foreach (b item in list)
		{
			if (item.d() == A_0)
			{
				return item;
			}
		}
		throw new ArgumentException();
	}

	private a d(Com.Raritan.RcCore.o.ColorDepth A_0)
	{
		List<a> list = (base.c ? o : p);
		foreach (a item in list)
		{
			if (item.f() == A_0)
			{
				return item;
			}
		}
		throw new ArgumentException();
	}

	public override List<Com.Raritan.RcCore.o.c> c()
	{
		List<Com.Raritan.RcCore.o.c> list = new List<Com.Raritan.RcCore.o.c>();
		List<c> list2 = (base.c ? k : l);
		foreach (c item in list2)
		{
			list.Add(item.a());
		}
		return list;
	}

	public override List<Com.Raritan.RcCore.o.ColorDepth> b()
	{
		List<Com.Raritan.RcCore.o.ColorDepth> list = new List<Com.Raritan.RcCore.o.ColorDepth>();
		List<a> list2 = (base.c ? o : p);
		foreach (a item in list2)
		{
			list.Add(item.f());
		}
		return list;
	}

	public override List<Com.Raritan.RcCore.o.Compression> a()
	{
		List<Com.Raritan.RcCore.o.Compression> list = new List<Com.Raritan.RcCore.o.Compression>();
		List<b> list2 = (base.c ? m : n);
		foreach (b item in list2)
		{
			list.Add(item.d());
		}
		return list;
	}

	public override List<Com.Raritan.RcCore.o.ColorDepth> a(Com.Raritan.RcCore.o.Compression A_0)
	{
		b b2 = d(A_0);
		return b2.b();
	}

	public override List<Com.Raritan.RcCore.o.Compression> b(Com.Raritan.RcCore.o.ColorDepth A_0)
	{
		a a2 = d(A_0);
		return a2.d();
	}

	public override Com.Raritan.RcCore.o.ColorDepth b(Com.Raritan.RcCore.o.c A_0)
	{
		c c2 = e(A_0);
		return c2.c();
	}

	public override Com.Raritan.RcCore.o.Compression a(Com.Raritan.RcCore.o.c A_0)
	{
		c c2 = e(A_0);
		return c2.d();
	}

	public override bool d(Com.Raritan.RcCore.o.c A_0)
	{
		c c2 = e(A_0);
		return c2.b();
	}

	public override void c(Com.Raritan.RcCore.o.c A_0)
	{
		c c2 = e(A_0);
		this.m_g = 2;
		this.m_h = c2.c();
		this.m_i = c2.d();
		j = c2.b();
	}

	public override void e()
	{
		this.m_g = 1;
	}

	public override void a(Com.Raritan.RcCore.o.ColorDepth A_0)
	{
		this.m_g = 3;
		this.m_h = A_0;
	}

	public override void a(bool A_0)
	{
		j = A_0;
	}

	public override void b(Com.Raritan.RcCore.o.Compression A_0)
	{
		this.m_g = 3;
		this.m_i = A_0;
	}

	public override void c(string A_0)
	{
		if (this.m_g == 0)
		{
			base.a.DebugFormat(Com.Raritan.Core.b.d("Using encoding type {0}"), A_0);
			if (A_0.ToLower().Equals("auto"))
			{
				this.m_g = 1;
			}
			else if (A_0.ToLower().Equals("preconf"))
			{
				this.m_g = 2;
			}
			else if (A_0.ToLower().Equals("manual"))
			{
				this.m_g = 3;
			}
			else
			{
				base.a.WarnFormat(Com.Raritan.Core.b.d("Unknown RFB encoding type received: {0}, using Auto"), A_0);
				this.m_g = 1;
			}
			base.b.an(this.m_g == 1);
		}
	}

	public override void a(string A_0)
	{
		if (this.m_g == 2)
		{
			base.a.DebugFormat(Com.Raritan.Core.b.d("Using predefined encoding {0}"), A_0);
			c(e(A_0));
			base.b.c(this.m_h);
			base.b.c(this.m_i);
			base.b.ap(j);
		}
	}

	public override void d(string A_0)
	{
		c(f(A_0));
	}

	private new void c(Com.Raritan.RcCore.o.Compression A_0)
	{
		if (this.m_g == 3)
		{
			base.a.DebugFormat(Com.Raritan.Core.b.d("Using compression {0}"), A_0);
			b(A_0);
			base.b.c(this.m_i);
		}
	}

	public override void b(string A_0)
	{
		c(g(A_0));
	}

	private new void c(Com.Raritan.RcCore.o.ColorDepth A_0)
	{
		if (this.m_g == 3)
		{
			base.a.DebugFormat(Com.Raritan.Core.b.d("Using color depth {0}"), A_0);
			a(A_0);
			base.b.c(this.m_h);
		}
	}

	public override uint[] f()
	{
		uint[] array = new uint[4];
		if (this.m_g == 1)
		{
			b b2 = d(Com.Raritan.RcCore.o.Compression.LEVEL_5);
			a a2 = d(Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT);
			if (base.c)
			{
				array[0] = 255u;
				array[1] = b2.c() | Com.Raritan.RcCore.Impl.Rfb.g.e(b2.a()) | Com.Raritan.RcCore.Impl.Rfb.g.d(a2.e());
			}
			else
			{
				array[0] = 127u;
				array[1] = b2.c() | Com.Raritan.RcCore.Impl.Rfb.g.e(b2.a()) | Com.Raritan.RcCore.Impl.Rfb.g.d(a2.c());
			}
		}
		else
		{
			b b3 = d(this.m_i);
			a a3 = d(this.m_h);
			array[0] = b3.c() | Com.Raritan.RcCore.Impl.Rfb.g.e(b3.a());
			if (!base.c)
			{
				array[0] |= Com.Raritan.RcCore.Impl.Rfb.g.d(a3.c());
			}
			else if (j)
			{
				array[0] |= Com.Raritan.RcCore.Impl.Rfb.g.d(a3.b());
			}
			else
			{
				array[0] |= Com.Raritan.RcCore.Impl.Rfb.g.d(a3.e());
			}
		}
		return array;
	}

	public override Com.Raritan.RcCore.Impl.Rfb.a d()
	{
		if (this.m_g == 1)
		{
			a a2 = d(Com.Raritan.RcCore.o.ColorDepth.COLOR_8_BIT);
			return a2.a();
		}
		a a3 = d(this.m_h);
		return a3.a();
	}
}
