using System;
using System.IO;
using System.Reflection;
using Com.Raritan.Core;
using Com.Raritan.Core.Impl;
using Com.Raritan.RcCore.Scan.Impl.Commands;

namespace Com.Raritan.RcCore.Scan.Impl.Rsp;

internal class g : Com.Raritan.Core.Impl.h, d
{
	private new volatile m i;

	private new readonly Com.Raritan.RcCore.Scan.Impl.b l;

	public g(Com.Raritan.RcCore.Scan.Impl.b A_0)
	{
		l = A_0;
	}

	protected virtual string d()
	{
		return "RSP";
	}

	protected virtual void c()
	{
	}

	protected virtual void b(byte A_0)
	{
	}

	protected virtual Com.Raritan.Core.e b(string A_0)
	{
		return new Com.Raritan.RcCore.Scan.a(A_0);
	}

	protected virtual void f()
	{
		new j().a(((Com.Raritan.Core.Impl.n)this).c);
		c c2 = (c)new c().a(((Com.Raritan.Core.Impl.n)this).b);
		a(c2);
		new a(c2.a(), c2.b()).a(((Com.Raritan.Core.Impl.n)this).c);
		q();
		i.a(this);
		i.a(l);
	}

	private new void a(c A_0)
	{
		string text = typeof(g).Namespace + "." + A_0.c() + ".RspProtoHandler" + A_0.c();
		((Com.Raritan.Core.Impl.n)this).d.Info("Loading CRP Protocol Handler impl class with name - " + text);
		Type type = Assembly.GetCallingAssembly().GetType(text);
		if ((object)type == null)
		{
			throw new Com.Raritan.RcCore.Scan.a("Unable to find the Handler class :" + text);
		}
		Type[] interfaces = type.GetInterfaces();
		bool flag = false;
		Type[] array = interfaces;
		foreach (Type type2 in array)
		{
			if (type2.IsGenericType && type2.GetGenericTypeDefinition().Equals(typeof(Com.Raritan.RcCore.Scan.Impl.Rsp.i<>)))
			{
				flag = true;
				break;
			}
		}
		if (!flag)
		{
			throw new Com.Raritan.RcCore.Scan.a("Protocol Handler does not derive from CRPProtoHandler class");
		}
		try
		{
			i = (m)Activator.CreateInstance(type, ((Com.Raritan.Core.Impl.n)this).d);
		}
		catch (Exception a_)
		{
			throw new Com.Raritan.RcCore.Scan.a(a_);
		}
	}

	protected virtual void e()
	{
		b();
		while (((Com.Raritan.Core.Impl.n)this).e)
		{
			a(i);
		}
	}

	private new void b()
	{
		if (base.c != null && base.d != null)
		{
			a(new Com.Raritan.RcCore.Scan.Impl.Commands.b(base.c, base.d));
			return;
		}
		if (base.f != null)
		{
			a(new Com.Raritan.RcCore.Scan.Impl.Commands.d(base.f));
			return;
		}
		if (base.e != null)
		{
			a(new Com.Raritan.RcCore.Scan.Impl.Commands.f(base.e));
			return;
		}
		throw new Com.Raritan.RcCore.Scan.a("No Authentication information available");
	}

	private new void a(m A_0)
	{
		a(A_0, A_0.b(bx()));
	}

	private new void a(m A_0, n A_1)
	{
		if (A_1 == null)
		{
			throw new Com.Raritan.RcCore.Scan.a("Protocol Error: Unknown Protocol message received");
		}
		A_1 = A_1.a(((Com.Raritan.Core.Impl.n)this).b);
		((Com.Raritan.Core.Impl.n)this).d.Info("Received Command " + A_1);
		A_0.a(A_1);
	}

	public new void a<a>(Com.Raritan.RcCore.Scan.Impl.Rsp.e<a> A_0)
	{
		((Com.Raritan.Core.Impl.n)this).d.Info("Sending command for execution - " + A_0);
		try
		{
			i.a(((Com.Raritan.Core.Impl.n)this).c, ((Com.Raritan.Core.Impl.n)this).b, A_0);
		}
		catch (IOException a_)
		{
			ab();
			this.a(A_0: false, (Exception)a_);
		}
		catch (Com.Raritan.RcCore.Scan.a a_2)
		{
			ab();
			this.a(A_0: false, (Exception)a_2);
		}
		catch (Exception a_3)
		{
			ab();
			this.a(A_0: false, a_3);
			throw;
		}
	}
}
