using System;
using System.Diagnostics;
using System.Threading;
using Com.Raritan.Core;
using Com.Raritan.Core.Impl;
using Com.Raritan.VmCore.Impl.Lsp;
using log4net;

namespace Com.Raritan.VmCore.Impl.App;

public class a
{
	public const string a = "launchEvent";

	public const string b = "stopEvent";

	public const string c = "pipe";

	public const string d = "vmhelper.exe";

	private static a m_e;

	private readonly ILog f;

	private string g;

	private string h;

	private string i;

	private EventWaitHandle j;

	private EventWaitHandle k;

	private Com.Raritan.Core.Impl.b l;

	private Process m;

	private Com.Raritan.VmCore.Impl.Lsp.c n;

	public static a a(ILog A_0)
	{
		if (Com.Raritan.VmCore.Impl.App.a.m_e == null)
		{
			Com.Raritan.VmCore.Impl.App.a.m_e = new a(A_0);
		}
		return Com.Raritan.VmCore.Impl.App.a.m_e;
	}

	private a(ILog A_0)
	{
		f = A_0;
	}

	protected virtual void e()
	{
		try
		{
			a(A_0: false);
		}
		finally
		{
			base.Finalize();
		}
	}

	private bool c()
	{
		if (m != null)
		{
			return !m.HasExited;
		}
		return false;
	}

	private void b()
	{
		m = null;
		l = null;
		n = null;
		string text = Com.Raritan.Core.b.d("Could not start VM helper application");
		DateTime now = DateTime.Now;
		g = "launch" + now.ToBinary();
		h = "stop" + now.ToBinary();
		i = "pipe" + now.ToBinary();
		j = new EventWaitHandle(initialState: false, EventResetMode.ManualReset, g);
		k = new EventWaitHandle(initialState: false, EventResetMode.ManualReset, h);
		l = new Com.Raritan.Core.Impl.b(f, i);
		string a_ = "launchEvent=" + g + " stopEvent=" + h + " pipe=" + i;
		Process process;
		try
		{
			process = Com.Raritan.Core.a.a("vmhelper.exe", a_);
		}
		catch (Exception exception)
		{
			f.Error(text, exception);
			throw new d(text);
		}
		if (!j.WaitOne(10000))
		{
			f.Error(Com.Raritan.Core.b.d("Timeout waiting for VM helper application to signal its initialization"));
			try
			{
				process.Kill();
			}
			catch
			{
			}
			throw new d(text);
		}
		f.Debug("VM helper application successfully started");
		m = process;
	}

	private void a()
	{
		l.b();
		n = new Com.Raritan.VmCore.Impl.Lsp.c(l, f);
	}

	private void a(bool A_0)
	{
		if (k != null && m != null)
		{
			k.Set();
			if (A_0)
			{
				m.WaitForExit();
			}
			m = null;
		}
	}

	internal Com.Raritan.VmCore.Impl.Lsp.c d()
	{
		if (c())
		{
			return n;
		}
		b();
		try
		{
			a();
		}
		catch
		{
			a(A_0: false);
			throw;
		}
		return n;
	}
}
